﻿/**
 * Объект, упрощающий работу с прямоугольниками
 */
batchApp.datacontext.RectHelper = {
	/**
	 * Повернуть прямоугольник
	 * @param rect Прямоугольник
	 * @param angle Угол поворота
	 * @param page Страница, к которой относится прямоугольник
	 */
	rotateRect: function (rect, angle, page) {
		switch (angle) {
			case 90:
				return {
					left: page.imageWidth() - rect.top - rect.height,
					top: rect.left,
					width: rect.height,
					height: rect.width
				};

			case 180:
				return {
					left: page.imageWidth() - rect.left - rect.width,
					top: page.imageHeight() - rect.top - rect.height,
					width: rect.width,
					height: rect.height
				};

			case -90:
				return {
					left: rect.top,
					top: page.imageHeight() - rect.left - rect.width,
					width: rect.height,
					height: rect.width
				};

			default:
				throw new Error('Invalid rotation angle ' + angle);
		}
	},
	/**
	 * Отразить прямоугольник
	 * @param rect Прямоугольник
	 * @param mode Способ отражения - по вертикали или по горизонтали
	 * @param page Страница, к которой относится прямоугольник
	 */
	flipRect: function (rect, mode, page) {
		switch (mode) {
			case FC.DocumentEditor.FlipMode.HORIZONTAL:
				return {
					left: page.imageWidth() - rect.left - rect.width,
					top: rect.top,
					width: rect.width,
					height: rect.height
				};

			case FC.DocumentEditor.FlipMode.VERTICAL:
				return {
					left: rect.left,
					top: page.imageHeight() - rect.top - rect.height,
					width: rect.width,
					height: rect.height
				};

			default:
				throw new Error('Invalid flip mode ' + mode);
		}
	}
};
