﻿window.scannerOptions = window.scannerOptions || {};
window.scannerOptions.viewModel = (function (ko, datacontext) {

	var scanners = ko.observableArray();
	var scannerProfile = ko.observable(new datacontext.ScannerProfile());

	var selectedScanner = ko.computed(function () {
		if ((!scanners()) || scanners().length === 0) return null;
		var res = null;
		var selectedScannerIndex = scannerProfile().scannerIndex();
		$.each(scanners(),
			function (key, value) {
				if (value.index() === selectedScannerIndex) {
					if (!value.isInitialized()) {
						datacontext.initScanner(value.scannerId(), value)
					}
					res = value;
				}
			});
		return res;
	});

	var scannerPropsVisible = ko.computed(function () {
		return selectedScanner() != null;
	}
    );

	var openSettings = function () {

		datacontext.openNativeSettings(scannerProfile());
	}


	var optionsWindow = null;

	$(document).ready(function () {
		$(document).ready(function () {
			$('ul.tabs').tabs();
		});
		var optionsWindowButtons = {
			OK: function () {
				if (selectedScanner()) {
					datacontext.saveOptions(scannerProfile());
				}

				optionsWindow.dialog('close');
			}
		};
		optionsWindowButtons[FC.Environment.Localization.Resource.CancelButton.toUpperCase()] = function () {
			optionsWindow.dialog('close');
		}

		$(window).resize(function () {
			fluidDialog();
		});

		$(document).on("dialogopen", ".ui-dialog", function (event, ui) {
			fluidDialog();
		});

		function fluidDialog() {
			var $visible = $(".ui-dialog:visible");
			// each open dialog
			$visible.each(function () {
				var $this = $(this);
				var dialog = $this.find(".ui-dialog-content").data("ui-dialog");
				if (dialog.options.fluid) {
					var wWidth = $(window).width();
					if (wWidth < (parseInt(dialog.options.maxWidth) + 50)) {
						$this.css("max-width", "90%");
					} else {
						$this.css("max-width", dialog.options.maxWidth + "px");
					}
					dialog.option("position", dialog.options.position);
				}
			});
		}

		optionsWindow = $('#ScanOptionsWindow').dialog({
			dialogClass: 'scanOptionsWindow',
			modal: true,
			width: 500,
			height: 400,
			draggable: false,
			autoOpen: false,
			fluid: true,
			title: FC.Environment.Localization.Batches.ScannerSettingsTitle,
			position: {
				my: "center",
				at: "center",
				of: "body"
			},
			buttons: optionsWindowButtons
		});
	});

	var openWindow = function () {
		datacontext.getScanningProps(scannerProfile);
		datacontext.getAvailableScannerOptions(scanners);
		optionsWindow.dialog('open');
	}

	return {
		scanners: scanners,
		scannerProfile: scannerProfile,
		selectedScanner: selectedScanner,
		openSettings: openSettings,
		openWindow: openWindow,
		scannerPropsVisible: scannerPropsVisible
	};

})(ko, window.scannerOptions.datacontext);

ko.applyBindings(window.scannerOptions.viewModel, document.getElementById("ScanOptionsWindow"));