﻿/**
* Модели для настроек типа пакета
**/

(function (ko, datacontext) {
	
	datacontext.ScanningProperties = ScanningProperties;

	//Класс настроек сканера
	function ScanningProperties(initInfo) {
		var self = this;

		initInfo = initInfo || {};

		//Использование несерверных настроек
		self.useSpec = ko.observable(true);

		//Выбранный интерфейс сканирования(драйвер или Abbyy)
		self.selectedInterface = ko.observable(initInfo.scannerInterface);

		//Индикатор открытия окна настроек сканера перед началом сканирования
		self.showWindowBeforeScan = ko.observable(initInfo.showBeforeScan);

		//Индекс сканера из списка всех сканеров
		self.scannerIndex = ko.observable(initInfo.scanIndex);

		self.returnToDefaults = function () {
			self.scannerIndex(null);
		}


		self.toJs = function() {
			return {
				selectedInterface: self.selectedInterface(),
				showWindowBeforeScan: self.showWindowBeforeScan(),
				scannerIndex: self.scannerIndex()
			};
		}
	}


})(ko, window.batchtypeSettings.datacontext);