﻿var RegTypePopupSelector = function (valuesEnum, offset) {
	var self = this;
	FC.PopupButton.apply(this, []);
	self.valuesEnum = valuesEnum;
	self.model = ko.observable();
	self.offset = offset;
	self.offset.subscribe(function () {
		if (self.isVisible()) {
			var elementPos = $('#' + self.domId).offset().top;
			var elementHeight = $('#' + self.domId).outerHeight();
			var topLimit = $('#parameters').offset().top;
			var bottomLimit = topLimit + $('#parameters').height();
			if ((elementPos - elementHeight / 2) < topLimit || (elementPos + elementHeight / 2) > bottomLimit) {
				self.close();
			} else {
				self.calculatePosition();
			}
		}
	});
	self.popupContainerId = '#regParamTypeChanger';
}


RegTypePopupSelector.prototype = Object.create(FC.PopupButton.prototype);

RegTypePopupSelector.prototype.constructor = RegTypePopupSelector;


var RegDropdownValueEditor = function (offset) {
	var self = this;
	FC.PopupButton.apply(this, []);
	
	self.model = ko.observable();
	self.popupContainerId = '#regDropdownValueEditor';
	self.offset = offset;
	self.offset.subscribe(function () {
		if (self.isVisible()) {
			var elementPos = $('#' + self.domId).offset().top;
			var elementHeight = $('#' + self.domId).outerHeight();
			var topLimit = $('#parameters').offset().top;
			var bottomLimit = $('.modalDialog__controls').offset().top;
			if ((elementPos - elementHeight / 2) < topLimit || (elementPos + elementHeight/2) > bottomLimit) {
				self.close();
			} else {
				self.calculatePosition();
			}
		}
	});

	self.addTemplate = function (method) {
		var field = $('#dropDownEditorInput');
		var caretPosition = FC.Utils.CaretTools.doGetCaretPosition(field[0]);
		var caretDiff = self.model().editableValue()[method](caretPosition).length;
		field.focus();
		FC.Utils.CaretTools.setCaretPosition(field[0], caretPosition + caretDiff);
	}


	self.model.subscribe(function(val) {
		if (val) {
			self.onConfirm = val.saveEditableRegValue;
			self.onClose = val.checkDropDownListIsEmpty;
		}
	});
}


RegTypePopupSelector.prototype = Object.create(FC.PopupButton.prototype);

RegTypePopupSelector.prototype.constructor = RegTypePopupSelector;

