﻿/**
 * ViewModel вкладки описания типа пакета
 * @param {} datacontext ОБект работы с данными
  */
var BackgrounSettingsViewmodel = function (datacontext, userIsAdmin) {
	var self = this;

	self.userIsAdmin = userIsAdmin;
	ScrollablePanel.apply(this, ['#uploading', '#uploadingContentFrame']);

	self.datacontext = datacontext;

	self.backgroundUploadProps = ko.observable();
	var sourceBackgroundUploadProps = ko.observable();

	//Обновление данных из плагина
	//Обновление данных из плагина
	self.updateInfo = function (batchType) {
		datacontext.getBackgroundUploadingProps(batchType, self.backgroundUploadProps);
		datacontext.getBackgroundUploadingProps(batchType, sourceBackgroundUploadProps);
	};

	//Сохранение данных
	self.saveInfo = function (batchType) {
		if (self.backgroundUploadProps()) {
			self.backgroundUploadProps().useSpec(true);
			datacontext.setBackgroundUploadingProps(batchType, self.backgroundUploadProps());
		}

	}

	var prevSubscriptions = [];
	self.backgroundUploadProps.subscribe(function (val) {
		if (prevSubscriptions.length > 0) {
			for (var i = prevSubscriptions.length - 1; i >= 0; i--) {
				prevSubscriptions[i].dispose();
			}
			prevSubscriptions.splice();
		}
		if (val) {
			prevSubscriptions.push(val.specifyUploadTime.subscribe(self.updateHeights));
			prevSubscriptions.push(val.repeatFailedUpload.subscribe(self.updateHeights));
			
		}
	});


	self.checkChanges = function () {
		if (!self.backgroundUploadProps() || !sourceBackgroundUploadProps()) {
			return false;
		}
		var settingsSerialized = JSON.stringify(self.backgroundUploadProps().toJs());
		var sourceSettingsSerialized = JSON.stringify(sourceBackgroundUploadProps().toJs());
		return settingsSerialized != sourceSettingsSerialized;
	}
}



BackgrounSettingsViewmodel.prototype = Object.create(ScrollablePanel.prototype);

BackgrounSettingsViewmodel.prototype.constructor = BackgrounSettingsViewmodel;
