﻿/**
 * ViewModel вкладки описания типа пакета
 * @param {} datacontext ОБект работы с данными
  */
var DocumentPropertiesViewmodel = function (datacontext, userIsAdmin) {
	var self = this;
	self.userIsAdmin = userIsAdmin;
	ScrollablePanel.apply(this, ['#document', '#documentContentFrame']);

	self.datacontext = datacontext;

	self.documentProperties = ko.observable();
	var sourceDocumentProperties = ko.observable();

	self.addTemplate = function (method) {
		var field = $('#NamingSchemeDocument');
		var caretPosition = FC.Utils.CaretTools.doGetCaretPosition(field[0]);
		var caretDiff = self.documentProperties().namingScheme()[method](caretPosition).length;
		field.focus();
		FC.Utils.CaretTools.setCaretPosition(field[0], caretPosition + caretDiff);
	}

	//Обновление данных из плагина
	//Обновление данных из плагина
	self.updateInfo = function (batchType) {
		datacontext.getDocumentProperties(batchType, self.documentProperties);
		datacontext.getDocumentProperties(batchType, sourceDocumentProperties);
	};

	//Сохранение данных
	self.saveInfo = function (batchType) {
		if (self.documentProperties()) {
			self.documentProperties().useSpec(true);

			
			datacontext.setDocumentProperties(batchType, self.documentProperties());
		}
		
	}



	var prevSubscriptions = [];
	self.documentProperties.subscribe(function(val) {
		if (prevSubscriptions.length > 0) {
			for (var i = prevSubscriptions.length - 1; i >= 0; i--) {
				prevSubscriptions[i].dispose();
			}
			prevSubscriptions.splice();
		}
		if (val) {
			prevSubscriptions.push(val.documentsSeparationTypeInd.subscribe(self.updateHeights));
			prevSubscriptions.push(val.emptyPageDetectOpts.subscribe(function(v) {
				prevSubscriptions.push(v.autoDetectKernalRect.subscribe(self.updateHeights));
			}));
		}
	});

	self.checkChanges = function () {
		if (!self.documentProperties() || !sourceDocumentProperties()) {
			return false;
		}
		var settingsSerialized = JSON.stringify(self.documentProperties().toJs());
		var sourceSettingsSerialized = JSON.stringify(sourceDocumentProperties().toJs());
		return settingsSerialized != sourceSettingsSerialized;
	}
}


DocumentPropertiesViewmodel.prototype = Object.create(ScrollablePanel.prototype);

DocumentPropertiesViewmodel.prototype.constructor = DocumentPropertiesViewmodel;
