﻿/**
 * ViewModel вкладки настроек сканнера для  типа пакета
 * @param {} datacontext ОБект работы с данными
  */
var ScannerOptsViewModel = function (datacontext, availableScanners, userIsAdmin) {
    var self = this;
	self.userIsAdmin = userIsAdmin;
	ScrollablePanel.apply(this, ['#scanning', '#scanningContentFrame']);
    self.datacontext = datacontext;
	self.selectedBatchType = null;
    //Список доупных сканеров
	self.availableScanners = availableScanners;

    //Настройки профиля сканирования
    self.scannerOptions = ko.observable();
	var sourceScannerOptions = ko.observable();


    //Выбранный сканер
    self.selectedScanner = ko.computed({

        read: function () {
            if (self.scannerOptions() == null)
                return null;
            if (self.availableScanners() == null)
                return null;
            for (var i = 0; i < self.availableScanners().length; i++) {
                var availableOption = self.availableScanners()[i];
                if (availableOption.Index === self.scannerOptions().scannerIndex())
                    return availableOption;
            }
            return null;
        },
        write: function (value) {
            if (value != undefined) {
                self.scannerOptions().scannerIndex(value.Index);
            } else {
                self.scannerOptions().scannerIndex(0);
            }

            
        }
    });

    //Функция открытия настройки сканера
    self.openSettings = function () {
		self.datacontext.openNativeSettings(self.selectedBatchType, self.selectedScanner());
    }

    //Обновление данных из плагина
	self.updateInfo = function (batchType) {
		self.selectedBatchType = batchType;
		self.datacontext.getScanningProps(batchType, self.scannerOptions);
		self.datacontext.getScanningProps(batchType, sourceScannerOptions);
    };

    //Сохранение данных
    self.saveInfo = function (batchType) {
    	if (self.scannerOptions()) {
    		self.scannerOptions().useSpec(true);
            self.datacontext.setScanningProps(batchType, self.scannerOptions());
        }
	}

	self.checkChanges = function () {
		if (!self.scannerOptions() || !sourceScannerOptions()) {
			return false;
		}
		var settingsSerialized = JSON.stringify(self.scannerOptions().toJs());
		var sourceSettingsSerialized = JSON.stringify(sourceScannerOptions().toJs());
		return settingsSerialized != sourceSettingsSerialized;
	}
}




ScannerOptsViewModel.prototype = Object.create(ScrollablePanel.prototype);

ScannerOptsViewModel.prototype.constructor = ScannerOptsViewModel;
