﻿window.Layouts = window.Layouts || {};

/**
 * ViewModel диалога установки параметров прокси для плагина сканирования
 */
window.Layouts.ProxyDialogViewModel = (function () {
	var self = FC.DialogBase(function () {
		if(self.confirmProxyCallback != undefined) {
			self.confirmProxyCallback(self.getProxyData(), location.reload());
		} else {
			location.reload();
		}
	}, function () {
		location.reload();
	},
		FC.Environment.ContentPath + "Content/images/icons128_scanner.png", true, true, true, false, true);

	/**
	 * Success callback
	 */
	self.confirmProxyCallback = null;

	/** Логин для авторизации на прокси сервере */
	self.login = ko.observable("");

	/** Пароль для авторизации на прокси сервере */
	self.password = ko.observable("");

	/**
	 * Отобразить диалог
	 * @param confirmDialogCallback колбек для передачи данных в плагин сканирования
	 */
	self.showDialog = function (confirmDialogCallback) {
		self.confirmProxyCallback = confirmDialogCallback;
		self.show();
	};

	/**
	 * Вернуть данные прокси из формы
	 * @returns {{password: string, username: string}}
	 */
	self.getProxyData = function () {
		return {
			username: self.login(),
			password: self.password()
		}
	}

	return self;
})();

$(document).ready(function() {
	var proxyDialogHost = document.getElementById("ProxyDialogHost");

	if (proxyDialogHost) {
		ko.applyBindings(window.Layouts.ProxyDialogViewModel, proxyDialogHost);
	}
});