﻿window.Layouts = window.Layouts || {};

/**
 * ViewModel диалога установки плагина сканирования
 */
window.Layouts.ScanPluginDialogViewModel = (function () {

	var self = FC.DialogBase(function () {
		window.location.href = FC.Environment.AppPathNoTennant + "ScanningPlugin" + (self.heavySelected() ?"WithPDF":"")+".exe";
	}, function () {
		location.reload();
	},
		FC.Environment.ContentPath + "Content/images/icons128_scanner.png", true, true, true, false, true);

	/**
	 * Текст ошибки
	 */
	self.error = ko.observable("");
	self.heavySelected = ko.observable(true);
	self.useHeavy = function() {
		self.heavySelected(true);
	}
	self.useLight = function () {
		self.heavySelected(false);
	}
	/**
	 * Отобразить диалог
	 * @param {} err Описание ошибки
	 * @returns {} 
	 */
	self.showDialog = function (err) {
		self.error(err);
		self.show();
	};

	return self;
})();

$(document).ready(function() {
	var scanPluginDialogHost = document.getElementById("ScanPluginDialogHost");

	if (scanPluginDialogHost) {
		ko.applyBindings(window.Layouts.ScanPluginDialogViewModel, scanPluginDialogHost);
	}
});