﻿ko.bindingHandlers.datepicker = {
    init: function (element, valueAccessor, allBindingsAccessor) {
        //initialize datepicker with some optional options
        var options = allBindingsAccessor().datepickerOptions || {};
        $(element).datepicker(options);
        $(element).datepicker("hide");

        //handle the field changing
        ko.utils.registerEventHandler(element, "change", function () {
            var observable = valueAccessor();

            // нужно сохранить время, которое было установлено в контроле
            var currentValue = observable();

            var currentTime = 0;
            if (currentValue && currentValue.hasOwnProperty('getHours')) {
                currentTime = currentValue.getHours() * 3600 + currentValue.getMinutes() * 60 + currentValue.getSeconds();
            }

            var selectedDate = $(element).datepicker("getDate");

            observable(new Date(selectedDate.valueOf() + currentTime * 1000));
        });

        //handle disposal (if KO removes by the template binding)
        ko.utils.domNodeDisposal.addDisposeCallback(element, function () {
            $(element).datepicker("destroy");
        });

    },
    //update the control when the view model changes
    update: function (element, valueAccessor) {
    	var value = ko.utils.unwrapObservable(valueAccessor());
        var current = $(element).datepicker("getDate");

        if (value - current !== 0) {
            $(element).datepicker("setDate", value);
        }
    }
};