﻿FC.BusinessModels.DocumentEditor.ChoiceField = function (initInfo, manipulators) {

	FC.BusinessModels.DocumentEditor.SimpleField.apply(this, arguments);

	initInfo = initInfo || {};

	FC.BusinessModels.DocumentEditor.FieldErrorExtend(manipulators, this);

	var self = this;
	this.values = ko.observableArray(initInfo.Values);
	this.minSelectedCount = ko.observable(initInfo.MinSelectedCount);
	this.maxSelectedCount = ko.observable(initInfo.MaxSelectedCount);
	this.variants = ko.observableArray([]);

	this.fields = ko.observableArray([]);

	this.selectedVariants = ko.computed(function () {
		var res = [];
		$.each(self.variants(),
			function(ind, value) {
				if (self.values().indexOf(value.id()) >= 0) {
					res.push(value.name());
				}
			});
		return res;
	});

	if (initInfo.Variants) {
		this.variants($.map(initInfo.Variants,
			function(val) {
				return new FC.BusinessModels.DocumentEditor.ChoiceVariant(val);
			}));
	}


}

FC.BusinessModels.DocumentEditor.ChoiceField.prototype = Object.create(FC.BusinessModels.DocumentEditor.SimpleField.prototype);

FC.BusinessModels.DocumentEditor.ChoiceField.prototype.constructor = FC.BusinessModels.DocumentEditor.ChoiceField;

/**
 * Получение JS Объекта 
 * @param {} fullSerialize  true - для всех свойств класса,  false для свойств класса необходимых при CHeck Rules и Apply Changes
 * @returns {} 
 */
FC.BusinessModels.DocumentEditor.ChoiceField.prototype.toJs = function (fullSerialize) {
	var simpleJs = this.simpleJs(fullSerialize);
	simpleJs.Values = this.values();
	simpleJs.Variants = $.map(this.variants(),
		function(variant) {
			return {
				Id: variant.id(),
				Name: variant.name()
			};
		});
	simpleJs.Fields = $.map(this.fields().filter(function (val) { return val; }), function (field) { return field.toJs(fullSerialize); });
	if (fullSerialize) {
		simpleJs.minSelectedCount = this.minSelectedCount();
		simpleJs.maxSelectedCount = this.maxSelectedCount();
	}
	return simpleJs;
}

FC.BusinessModels.DocumentEditor.ChoiceField.prototype.updateInfo = function (newInfo) {
	this.values(newInfo.Values || []);
	this.isVerified(newInfo.IsVerified || false);
	this.needRecognize(newInfo.NeedRecognize);
	this.isReadOnly(newInfo.IsReadOnly || false);
}