﻿FC.BusinessModels.DocumentEditor.Error = function(error) {
	
	this.documentNodeRef = ko.observableArray(error.DocumentNodeRef);

	this.severity = ko.observable(error.Severity == 1);

	this.type = ko.observable(error.Type);

	this.message = ko.observable(error.Message);

	this.contextNodeRef = ko.observableArray(error.ContextNodeRef);

	this.focusedNodeRef = ko.observableArray(error.FocusedNodeRef);

	this.ruleName = ko.observable(error.RuleName);
};


FC.BusinessModels.DocumentEditor.Error.prototype.toJs = function () {
	return {
		DocumentNodeRef: this.documentNodeRef(),
		Severity: this.severity()?1:0,
		Type: this.type(),
		Message: this.message(),
		ContextNodeRef: this.contextNodeRef(),
		FocusedNodeRef: this.focusedNodeRef(),
		RuleName: this.ruleName()
	};
}

FC.BusinessModels.DocumentEditor.ErrorType = {
	RuleError:0,
	FormatError:1,
	MergeVersionError:2,
	UnmatchedRegionError:3,
	ErrorInChildDocument:4
}