﻿FC.BusinessModels.DocumentEditor.Page = function(page, urlGenerator) {


	this.urlGenerator = urlGenerator;
	this.id = ko.observable(page.Id);
	this.modification = ko.observable(page.Modification);
	this.hasColorImage = ko.observable(page.HasColorImage);
	this.imageResolution = ko.observable(page.ImageResolution);
	this.keyValue = ko.observable(page.KeyValue);
	this.sectionTemplateId = ko.observable(page.SectionTemplateId);
	this.sectionTemplateName = ko.observable(page.SectionTemplateName);
	this.flexibleInstanceId = ko.observable(page.FlexibleInstanceId);
	this.sectionTemplatePageNumber = ko.observable(page.SectionTemplatePageNumber);
	this.comment = ko.observable(page.Comment);
	this.width = ko.observable(page.ImageWidth);
	this.height = ko.observable(page.ImageHeight);

	this.url = ko.computed(function() {
		return urlGenerator(this.id(), this.modification(), this.hasColorImage());
		},
		this);

	this.dispose = function() {
		this.url.dispose();
	};
};

FC.BusinessModels.DocumentEditor.Page.prototype.toJs = function () {
	return {
		Id: this.id(),
		Modification: this.modification(),
		HasColorImage: this.hasColorImage(),
		ImageResolution: this.imageResolution(),
		KeyValue: this.keyValue(),
		SectionTemplateId: this.sectionTemplateId(),
		SectionTemplateName: this.sectionTemplateName(),
		FlexibleInstanceId: this.flexibleInstanceId(),
		SectionTemplatePageNumber: this.sectionTemplatePageNumber(),
		Comment: this.comment(),
		ImageWidth: this.width(),
		ImageHeight: this.height()
	};
}
