﻿FC.BusinessModels.DocumentEditor.Section = function (section, document, manipulators) {
	FC.BusinessModels.DocumentEditor.FieldErrorExtend(manipulators, this);
	FC.BusinessModels.DocumentEditor.BasicField.apply(this, arguments);
	section = section || {};
	this.id = ko.observable(section.Id);
	this.name = ko.observable(section.Name);
	this.caption = ko.observable(section.Caption);
	this.pageIds = ko.observableArray(section.PageIds);
	this.isFlexible = ko.observable(section.IsFlexible);
	this.fields = ko.observable([]);

	this.isVisible = ko.observable(section.IsVisible);

	this.parent = null;
	this.document = document;
};

FC.BusinessModels.DocumentEditor.Section.prototype = Object.create(FC.BusinessModels.DocumentEditor.BasicField.prototype);

FC.BusinessModels.DocumentEditor.Section.prototype.constructor = FC.BusinessModels.DocumentEditor.Section;


FC.BusinessModels.DocumentEditor.Section.prototype.isRepeatableField = function() { return false; };

FC.BusinessModels.DocumentEditor.Section.prototype.getRepeatableContext = function() {
	if (this.parent) return [this.parent.fields().indexOf(this)];

	return [];
};

/**
 * Получение JS Объекта 
 * @param {} fullSerialize  true - для всех свойств класса,  false для свойств класса необходимых при CHeck Rules и Apply Changes
 * @returns {} 
 */
FC.BusinessModels.DocumentEditor.Section.prototype.toJs = function (fullSerialize) {
	var res = {
		Fields: $.map(this.fields().filter(function (val) { return val; }), function (field) { return field.toJs(fullSerialize); }),
		Id: this.id(),
		Name: this.name(),
		PageIds: this.pageIds(),
		FieldType: FC.BusinessModels.DocumentEditor.FieldTypes.Section
	}

	if (fullSerialize) {
		res.isFlexible = this.isFlexible();
		res.isVisible = this.isVisible();
	}

	return res;

}
