﻿FC.BusinessModels.DocumentEditor.SectionsGroup = function (initInfo, document, manipulators) {
	initInfo = initInfo || {};

	FC.BusinessModels.DocumentEditor.FieldErrorExtend(manipulators, this);
	this.fieldType = FC.BusinessModels.DocumentEditor.FieldTypes.SectionsGroup;
	this.id = ko.observable(initInfo.Id);
	this.name = ko.observable(initInfo.Name);
	this.caption = this.name;
	this.document = document;
	this.fields = ko.observableArray([]);
	this.isVisible = ko.observable(true);
	this.dummy = ko.observable(initInfo.Dummy);

	function createDummyViewmodel(field, parent) {
		var t0 = performance.now();
		var fieldModel = new FC.BusinessModels.DocumentEditor.Section(field, manipulators);
		
		fieldModel.parent = parent;
		

		FC.Utils.EventLogger.Default.addMessage("BMFUNC", "FieldsGroup createDummyViewmodel\t" + (performance.now() - t0) + "\tms");
		return fieldModel;
	}

	this.createField = function () {
		var t0 = performance.now();
		var dummyField = this.dummy() ? createDummyViewmodel(this.dummy(), this) : null;
		if (dummyField && dummyField.id) {
			dummyField.id(0);
		}
		FC.Utils.EventLogger.Default.addMessage("BMFUNC", "FieldsGroup createField\t" + (performance.now() - t0) + "\tms");
		return dummyField;
	}
}

/**
 * Получение JS Объекта 
 * @param {} fullSerialize  true - для всех свойств класса,  false для свойств класса необходимых при CHeck Rules и Apply Changes
 * @returns {} 
 */
FC.BusinessModels.DocumentEditor.SectionsGroup.prototype.toJs = function (fullSerialize) {
	return {
		Sections: $.map(this.fields().filter(function (val) { return val; }), function (field) { return field.toJs(fullSerialize); }),
		Id: this.id(),
		Name: this.name(),
		FieldType: FC.BusinessModels.DocumentEditor.FieldTypes.SectionsGroup
	};
	
}

FC.BusinessModels.DocumentEditor.SectionsGroup.prototype.addRepeatedItem = function () {
	return this.addRepeatedItemOnIndex(this.fields().length);
};

FC.BusinessModels.DocumentEditor.SectionsGroup.prototype.addRepeatedItemOnIndex = function (index) {
	var newInstance = this.createField();
	var instances = this.fields();
	if (index === 0) {
		instances.unshift(newInstance);
	} else if (index > instances.length - 1) {
		instances.push(newInstance);
	} else {
		instances.splice(index, 0, newInstance);
	}

	this.fields(instances);
	FC.Viewmodels.EventStack.addEvent();

	return newInstance;
};

FC.BusinessModels.DocumentEditor.SectionsGroup.prototype.isRepeatableField = function () { return true; }