﻿FC.BusinessModels.DocumentEditor.SuggestsManipulator = function (allFields) {
	this.allFields = allFields;

	this.suggestsDict = ko.observableArray([]);

	function findTextFields(field) {
		var t0 = performance.now();

		var res = [];
		if (field instanceof FC.BusinessModels.DocumentEditor.TextField) {
			res.push(field);
		}
		
		if (field.fields && field.fields()) {
			$.each(field.fields(),
				function (key, subField) {
					res = res.concat(findTextFields(subField));
				});
		}
		if (field.rows && field.rows()) {
			$.each(field.rows(),
				function (key, subField) {
					res = res.concat(findTextFields(subField));
				});
		}
		if (field.cell && field.cell()) {
			$.each(field.cell(),
				function (key, subField) {
					res = res.concat(findTextFields(subField));
				});
		}

		FC.Utils.EventLogger.Default.addMessage("BMFUNC", "SuggestsManipulator.findTextFields\t" + (performance.now() - t0) + "\tms");
		return res;

		
	}

	this.updateDict = function () {
		
		var t0 = performance.now();
		var suggestsDict = {};
		var textFields = [];
		$.each(this.allFields(), function (ind, val) { return textFields = textFields.concat(findTextFields(val)); });
		$.each(textFields,
			function (index, field) {
				var serializedPath = field.getFieldKeyWithoutRepeateIndex().join();
				var fieldSuggests = field.suggests();
				if (!suggestsDict[serializedPath]) {
					if (fieldSuggests && fieldSuggests.length) {
						suggestsDict[serializedPath] = fieldSuggests.slice();
					}
				}
			});
		FC.Utils.EventLogger.Default.addMessage("BMFUNC", "SuggestsManipulator suggestsDict\t" + (performance.now() - t0) + "\tms");
		this.suggestsDict(suggestsDict);
	};


}