﻿FC.BusinessModels.DocumentEditor.TableRegion = function (initInfo, table, pages, isVisible, isLocked, isSectionRegion) {
	FC.BusinessModels.DocumentEditor.Region.apply(this, [initInfo, pages, isVisible, isLocked, isSectionRegion]);

	initInfo = initInfo || {};
	this.horizontalSeparators = ko.observableArray(
		ko.utils.arrayMap(initInfo.HorizontalSeparators, function (s) { return ko.observable(s); }));

	this.columns = ko.observableArray([]);
	this.dummyRow = table.DummyRow;
	this.isRepeatableGroup = table.IsRepeatableGroup;

	if (initInfo.Columns) {
		this.columns($.map(initInfo.Columns, function (value) {
			var caption = "";

			for (var i = 0; i < table.DummyRow.Cells.length; i++) {
				if (table.DummyRow.Cells[i].Id == value.Id) {
					caption = table.DummyRow.Cells[i].Caption ? table.DummyRow.Cells[i].Caption : table.DummyRow.Cells[i].Name;
				}
			}


			return new FC.BusinessModels.DocumentEditor.TableColumn(value, caption);
		}));
	}
}

FC.BusinessModels.DocumentEditor.TableRegion.prototype = Object.create(FC.BusinessModels.DocumentEditor.Region.prototype);

FC.BusinessModels.DocumentEditor.TableRegion.prototype.constructor = FC.BusinessModels.DocumentEditor.TableRegion;

FC.BusinessModels.DocumentEditor.TableRegion.compare = function (tableRegion1, tableRegion2) {
	if (!tableRegion1 || !tableRegion2) {
		return 0;
	}

	var getExternalRect = function (region) {
		var rects = region.coordinates();

		// найдём крайние точки полигона
		var bigNumber = 1000000;
		var minX = bigNumber, minY = bigNumber, maxX = -bigNumber, maxY = -bigNumber;

		for (var i = 0; i < rects.length; i++) {
			if (rects[i].x1() < minX) {
				minX = rects[i].x1();
			}

			if (rects[i].x2() > maxX) {
				maxX = rects[i].x2();
			}

			if (rects[i].y1() < minY) {
				minY = rects[i].y1();
			}

			if (rects[i].y2() > maxY) {
				maxY = rects[i].y2();
			}
		}

		return {
			x1: minX,
			x2: maxX,
			y1: minY,
			y2: maxY
		};
	};

	var rect1 = getExternalRect(tableRegion1);
	var rect2 = getExternalRect(tableRegion2);

	if (rect1.y1 !== rect2.y1) {
		return rect1.y1 - rect2.y1;
	}

	return rect1.x1 - rect2.x1;
};

