﻿FC.BusinessModels.DocumentEditor.TableRow = function (tableRow, manipulators) {


	FC.BusinessModels.DocumentEditor.FieldErrorExtend(manipulators, this);
	this.internalId = FC.BusinessModels.DocumentEditor.BasicField.IdScore++;
	
	this.cell = ko.observableArray([]);
	this.tableBlockId = ko.observableArray(tableRow.TableBlockId);
	this.rowNumber = ko.observable(tableRow.RowNumber);
	this.id = ko.observable(tableRow.Id);

	this.parent = null;
	this.name = function() {
		return this.parent ? this.parent.name() : 'row';
	};

	this.caption = this.name;
};


FC.BusinessModels.DocumentEditor.TableRow.prototype.toJs = function (fullSerialize) {
	return {
		Cells: $.map(this.cell(), function (cell) { return cell.toJs(fullSerialize); }),
		Id: this.id(),
		RowNumber: this.rowNumber(),
		TableBlockId: this.tableBlockId()
	};
}

FC.BusinessModels.DocumentEditor.TableRow.prototype.isRepeatableField = function() {
	return false;
}


/**
 * Получить путь к строке (состоящий из id родителей)
 * @returns {}  массив идентификаторов родителей строки
 */
FC.BusinessModels.DocumentEditor.TableRow.prototype.getFieldPath = function () {
	var path = this.parent.getFieldPath();

	path.push({
		type: FC.Viewmodels.FormEditor.IndexType.RepeateIndex,
		id: this.id()
	});

	return path;
};

/**
 * Получить ссылку на ряд в формате id1\id2\id3...
 * @returns {} строковая ссылка
 */
FC.BusinessModels.DocumentEditor.TableRow.prototype.getRowNodeRef = function () {
	var path = this.getFieldPath();
	var ref = "";
	for (var i = 0; i < path.length; i++) {
		if (path[i].type === FC.Viewmodels.FormEditor.IndexType.RepeateIndex) {
			ref += "-";
		}
		ref += path[i].id;
		if (i < path.length - 1) {
			ref += "\\";
		}
	}

	return ref;
};