﻿var self = this;

var styles = {
	display: 'block',
	position: 'absolute',
	top: '0px',
	bottom: '0px',
	left: '0px',
	right: '0px',
	width: '100%',
	height: '100%',
	border: '0',
	overflow: 'hidden',
	'overflow-x': 'hidden',
	'overflow-y': 'hidden',
	'z-index': '10000'
}

self.executeAsync("getLocalization",
	null,
	function(res) {
		var localization = res.detail.result;
	
//Задаем стили отображения iframe
self.executeAsync("setStyles", styles, function () {
	//Текущий выбранный DataSet
	var currentSelected = [];
	//Список полей из основной формы
	var filters = [];
	//Искомая секция в документе
	var targetSection;

	var document = commandArgs.params.document;
	//Секция, в которой лежат остальные
	var mainSection = document.Fields[0];

	window.mainSectionName = mainSection.Name;

	var sectionFields = mainSection.Fields;
	//Ищем секцию Vendor
	for (var i = 0; i < sectionFields.length; i++) {
		if (sectionFields[i].Name === targetFieldName) {
			targetSection = sectionFields[i];
			break;
		}
	}
	//Инициализируем фильтр и выбранное значение по умолчанию
	if (targetSection != undefined) {
		$.each(targetSection.Fields, function (key, field) {
			currentSelected.push({ FieldName: field.Name, FieldValue: field.Value });
			filters.push({ FieldName: field.Name, FieldValue: field.Value });
		});
	}
	//Список доступных датасеов
	var clearData = [currentSelected];

	//Порядок вывода Fields
	var fieldsOrder = [];
	$.each(currentSelected, function (index, field) {
		fieldsOrder.push(field.FieldName);
	});


	var $screenLocker = $('<div id="screenLocker"></div>');
	var $incorrectInput = $('<div class="incorrectInput">' + localization.EmptyInputError+'</div>');
	//Создаем структуру страницы в iframe
	$("body").append('<div id="modalWindow"></div>');
	
	
	var editPanelContent = $('<table id="entityTable"> \
								<tbody> \
								</tbody> \
							</table>');
	$.each(availableColumns, function (index, val) {
		var isRequired = requiredColumns.indexOf(val) > -1;
		editPanelContent.children().append('<tr><td>' + val + (isRequired ? "*" : "") + '</td><td><input type="text" id="' + val + '" class="clearable ' + (isRequired?"required":'')+'"></td></tr>');
	});
	
	var dialogContent = '<div id="observePanel"><div id ="searchArea"> \
			<input type="text" id="searchText" placeholder="'+ localization.StartTypingPrompt+'"class="clearable"/> \
		</div> \
		<div id="resultsView"> \
			<ul id="autocompleteVariants"></ul> \
			<div id="selectedVariantsArea" data-clearDataIndex="0"><table id="selectedVariant"></table></div> \
		</div></div>';

	var editButtonsPanel = '<div id="editEntityButtons" class="ui-dialog-buttonset"> \
								<button id="editEntity" type="button" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-only weak" role="button">' +
									'<span class="ui-button-text">' + localization.EditRecordButton + '</span>' +
								'</button>' +
								'<button type="button" id="addEntity" class="ui-button ui-widget ui-state-default ui-corner-all ui-button-text-only weak" role="button">' +
									'<span class="ui-button-text">' + localization.AddRecordButton + '</span>' +
								'</button> \
							</div>';
	$('#modalWindow')
		.append(dialogContent)
		.append(editPanelContent)
		.append(editButtonsPanel);
		

	var $idNode = $("#entityTable input").filter(function () {
		return $(this).attr('id').toLowerCase() === primaryKey.toLowerCase();
	});
	//Выжирнение значения по маске
	var boldifyValue = function (currentField) {
		var value = currentField.FieldValue;
		if ((currentField.BoldMask != undefined) && (currentField.BoldMask.length !== 0)) {
			var lastPos = -1;
			var charPos;
			for (charPos = currentField.BoldMask.length - 1; charPos >= 0; charPos--) {
				if (currentField.BoldMask[charPos] === '0') {
					if (lastPos >= 0) {
						value = value.slice(0, lastPos + 1) + '</b>' + value.slice(lastPos + 1);
						value = value.slice(0, charPos + 1) + '<b>' + value.slice(charPos + 1);
						lastPos = -1;
					}
				}
				else if (currentField.BoldMask[charPos] === '1') {
					if (lastPos < 0)
						lastPos = charPos;
				}
			}
			if (lastPos > 0) {
				value = value.slice(0, lastPos + 1) + '</b>' + value.slice(lastPos + 1);
				value = '<b>' + value.slice(charPos + 1);
			}
		}

		return value;
	}

	//Обновление выбранного значения
	var updateSelectedValue = function (selectedValue) {
		$("#selectedVariant tr").remove();
		currentSelected = selectedValue;
		$.each(fieldsOrder, function (index, fieldName) {
			for (var i = 0; i < selectedValue.length; i++) {
				var currentField = selectedValue[i];
				if (currentField.FieldName.toUpperCase() === fieldName.toUpperCase()) {
					var value = boldifyValue(currentField);

					var newRow = $("<tr></tr>");
					newRow.append("<td>" + fieldName + ":</td>");
					newRow.append("<td>" + value + "</td>");
					$("#selectedVariant").append(newRow);
				}
			}

		});
	}

	//Обновление списка доступных DataSetов на интерфейсе
	var updateAvailableValuesList = function (selectedValues, searched) {
		$("#autocompleteVariants").find('li').remove();

		$.each(selectedValues, function (dataItemKey, dataItem) {
			var name = "";
			var otherFields = "";
			$.each(dataItem, function (fieldDescrKey, fieldDescr) {
				if (fieldDescr.FieldName === "Name") {
					name = boldifyValue(fieldDescr);
				} else {
					if (searched && (fieldDescr.BoldMask != undefined) && (fieldDescr.BoldMask.length !== 0)) {
						if (otherFields.length > 0) {
							otherFields += " ";
						}
						otherFields += fieldDescr.FieldName + ": " + boldifyValue(fieldDescr);

					}
				}
			});

			$("#autocompleteVariants")
				.append($("<li data-index='" + dataItemKey + "'></li>")
				.append($("<div class='variants-title'>" + name + "</div>"))
				.append($("<div class='variants-subTitle'>" + otherFields + "</div>")));
		});

		if (searched && clearData && clearData.length > 0) {
			updateSelectedValue(clearData[0]);
		}
	};

	var closeFormAndSelect = function () {
		$.each(currentSelected, function (key, value) {
			for (var i = 0; i < targetSection.Fields.length; i++) {
				if (targetSection.Fields[i].Name == value.FieldName) {
					targetSection.Fields[i].Value = value.FieldValue;
				}
			}
		});

		//Отправляем ответ на команду Launch. ID обязателен, по нему определяется на что пришел ответ
		self.sendResponse(commandArgs.id, document);
	}

	var addSelected = false;
	var switchPanels = function (isAdd) {
		if ($('#observePanel').is(':visible')) {
			addSelected = isAdd;
			$('#entityTable').show();
			$('.incorrectInput').remove();
			$('#observePanel').hide();
			$("#editEntityButtons").hide();
			$('.ui-dialog-buttonpane button').eq(2).hide();
			$('.ui-dialog-title').html(isAdd ? localization.AddRecordHeader : localization.EditRecordHeader);
			
		}
		else {
			$('#entityTable').hide();
			$('#observePanel').show();
			$('.ui-dialog-title').html(localization[modalWindowTitle]);
			$('.ui-dialog-buttonpane button').eq(2).show();
			$("#editEntityButtons").show();
		}
	}

	var confirmChanges = function () {
		$('.ui-dialog').prepend($screenLocker);

		$screenLocker.show();
		var columns = [];
		var values = [];
		currentSelected.splice();

		var hasError = false;
		$('#entityTable input').each(function () {
			var $elem = $(this);
			var key = $elem.attr('id');
			var val = $elem.val();
			if ($elem.hasClass('required') && (!val)) {
				hasError = true;
				var currentIncorrectInputLocker = $incorrectInput.clone();
				if ($elem.prev('.incorrectInput').length === 0) {
					currentIncorrectInputLocker.insertBefore($elem);
					currentIncorrectInputLocker.click(function() {
						$(this).remove();
						$elem.focus();
					});
				}
			}
			if (val.length > 0) {
				columns.push(key);
				values.push(val);
			}
			currentSelected.push({ FieldName: key, FieldValue: val});
		});

		if (hasError) {
			$screenLocker.remove();
			return;
		}
		if (addSelected) {
			self.executeAsync("addEntity",
				{ cacheName: dbCacheName, columns: columns, values: values },
				function(result) {
					currentSelected.push({ FieldName: primaryKey, FieldValue: result.detail.result });
					closeFormAndSelect();
				});
		} else {
			self.executeAsync("editEntity",
				{ cacheName: dbCacheName, primaryKey: primaryKey, columns: columns, values: values },
				function (result) {
					closeFormAndSelect();
				});
		}


	}

	var buttons = {};
	buttons[localization.OkButton] = function() {
		if ($('#observePanel').is(':visible')) {
			closeFormAndSelect();
		} else {
			confirmChanges();
		}
	};
	buttons[localization.CancelButton] = function () {
		//Отправляется пустой ответ. Пустой ответ не обрабатывается
		if ($('#observePanel').is(':visible')) {
			self.sendResponse(commandArgs.id, "");
		} else {
			switchPanels();
		}
	}
	buttons[localization.ResetDataButton] = function() {
		for (var i = 0; i < targetSection.Fields.length; i++) {
			targetSection.Fields[i].Value = "";
			targetSection.Fields[i].Regions = [];
		}


		//Отправляем ответ на команду Launch. ID обязателен, по нему определяется на что пришел ответ
		self.sendResponse(commandArgs.id, document);
	};

	
	$('#modalWindow').dialog({
		modal: true,
		width: 700,
		height: 800,
		draggable: false,
		title: localization[modalWindowTitle],
		position: {
			my: "center",
			at: "center",
			of: "body"
		},
		buttons: buttons,
		close: function () {
			self.sendResponse(commandArgs.id, "");
		}
	});

	//Выбор из списка
	$("#autocompleteVariants").delegate("li", "click", function () {
		var index = $(this).attr("data-index");
		updateSelectedValue(clearData[index]);
		$("#autocompleteVariants li.selected").toggleClass('selected');
		$(this).toggleClass('selected');
	});

	//Выбор из списка
	$("#autocompleteVariants").delegate("li", "dblclick", function () {
		var index = $(this).attr("data-index");
		updateSelectedValue(clearData[index]);
		closeFormAndSelect();
	});

	//Реакция на изменение значения в поле поиска
	$("#searchText").bind("input", function () {
		var currentValue = $(this).val();
		//Изменнеие подсветки кнопок
		$(".ui-dialog-buttonpane .ui-button:first-child")[tog(currentValue.length === 0)]("weak");
		$(".ui-dialog-buttonpane .ui-button:last-child")[tog(currentValue.length !== 0)]("weak");

		//Позиция курсора в input
		var cursorPos = 0;
		//Фильтр запроса. Добавляем пару "", "значение в поле поиска"
		var currentFilters = filters.slice();
		for (var i = currentFilters.length-1; i >=0; i--) {
			if (currentFilters[i].FieldName === primaryKey && currentFilters[i].FieldValue.indexOf('UNKNOWN') > -1) {
				currentFilters.splice(i, 1);
			}
		}
		var searched = false;

		if (currentValue.length > 2) {
			cursorPos = currentValue.length;
			currentFilters = [{ FieldName: "", FieldValue: currentValue }];
			searched = true;
		}

		//Запрос словаря
		self.executeAsync("getDict", { cacheName: dbCacheName, filters: currentFilters, cursorPos: cursorPos }, function (result) {
			clearData = result.detail.result;
			//Обновление списка доступных датасетов
			updateAvailableValuesList(clearData, searched);
			//Поиск и перевыжирнение выбранного датасетавыбранного 
			var updatedSelected;
			var updatedSelectedIndex;
			for (var i = 0; i < clearData.length; i++) {
				var dataSet = clearData[i];
				var isEqual = true;
				var numOfFoundProperties = 0;
				for (var j = 0; j < dataSet.length; j++) {
					var property = dataSet[j];
					for (var k = 0; k < currentSelected.length; k++) {
						var selectedObjectProperty = currentSelected[k];

						if (selectedObjectProperty.FieldName.toUpperCase() === property.FieldName.toUpperCase()) {

							if (selectedObjectProperty.FieldValue !== property.FieldValue) {
								isEqual = false;
							}
							numOfFoundProperties++;
							break;
						}
					}

					if (!isEqual) {
						break;
					}
				}
				if (numOfFoundProperties < fieldsOrder.length) {
					isEqual = false;
				}
				if (isEqual) {
					updatedSelected = dataSet;
					updatedSelectedIndex = i;
				}
			}

			if (updatedSelected != undefined) {
				updateSelectedValue(updatedSelected);
				$("#autocompleteVariants li").eq(updatedSelectedIndex).toggleClass('selected');
			}

		});

	});
	
	//Крестик у Input
	function tog(v) { return v ? 'addClass' : 'removeClass'; }
	$(document).on('input change paste keyup', '.clearable', function () {
		$(this)[tog(this.value)]('x');
	}).on('mousemove', '.x', function (e) {
		$(this)[tog(this.offsetWidth - 18 < e.clientX - this.getBoundingClientRect().left)]('onX');
	}).on('touchstart click', '.onX', function (ev) {
		ev.preventDefault();
		$(this).removeClass('x onX').val('').trigger('input');
	});

	//Ввод выбранного значения по умолчанию
	if ($("#selectedVariant tr").length === 0) {
		updateSelectedValue(clearData[0]);
	}
	//Запуск первичного поиска
	$("#searchText").trigger('input');


	$("#addEntity").click(function () {
		$("#entityTable input").val('');
		$idNode.parents('tr').hide();
		switchPanels(true);
	});

	$("#editEntity").click(function () {
		
		$idNode.parents('tr').show();
		$idNode.prop("disabled", true);
		$.each(currentSelected, function (ind, val) {
			$("#" + val.FieldName).val(val.FieldValue);
		});
		switchPanels(false);
		
	});
		});


	});