﻿var self = this;
var fieldName = "City";
var styles = {
	display: 'block',
	position: 'absolute',
	top: '0px',
	bottom: '0px',
	left: '0px',
	right: '0px',
	width: '100%',
	height: '100%',
	border: '0',
	overflow: 'hidden',
	'overflow-x': 'hidden',
	'overflow-y': 'hidden',
	'z-index': '10000'
}
self.executeAsync("setStyles", styles, function () {
    
		$("body").append('<div id="modalWindow"></div>');

		$('#modalWindow').append('<input type="text" id="autocompleteText" placeholder="Start typing" class="clearable"/><ul id="autocompleteVariants"></ul>');
		$("#autocompleteVariants").css("width","100%");
		$('#modalWindow').dialog({
			modal: true,
			width: 275,
			height: 500,
			title: "Select city",
			position: {
				my: "center",
				at: "center",
				of: "body"
			},
			buttons: {
            	OK: function () {
            		if ($("#autocompleteText").val().length>0)
            			self.sendResponse(commandArgs.id, [{ Path: ["Vendor", "City"], Value: $("#autocompleteText").val() }]);
            		else
            			self.sendResponse(commandArgs.id, "");
				},
				CANCEL: function () {
					self.sendResponse(commandArgs.id, "");
				}
			},
			close: function () {
				self.sendResponse(commandArgs.id, "");
			}
		});

		self.executeAsync("getDictAll", {cacheName: "Vendors"}, function (result) {
			var availableFieldValues = [];


			var dictionary = result.detail.result;
			$.each(dictionary, function (indexRow, row) {
				$.each(row, function (indexColumn, element) {
					if (element.FieldName !== fieldName)
						return;
					
					if (element.FieldValue.length === 0)
						return;

					if ($.inArray(element.FieldValue, availableFieldValues) < 0)
						availableFieldValues.push(element.FieldValue);
				});
			});

			var updateSelectValuesFunc = function (preIns) {                    
				
				var selectedValues;
                
				if (preIns === undefined || !preIns || preIns.length === 0)
					selectedValues = availableFieldValues;
				else {
					selectedValues = [];
					$.each(availableFieldValues, function (key, value) {
						if (value.toUpperCase().indexOf(preIns.toUpperCase()) === 0)
							selectedValues.push(value);
					});
				}
                
				$("#autocompleteVariants").find('li').remove();
				$.each(selectedValues, function (key, value) {
					var newOption = $("<li></li>");
					newOption.append($("<a></a>").append(value.replace(new RegExp(preIns,'gi'), '<b>$&</b>')));
					$("#autocompleteVariants").append(newOption);
				});
			};

            

			$("#autocompleteVariants").delegate("a", "click",function () {
				$("#autocompleteText").val($(this).text()).change();
			});

			$("#autocompleteText").bind("input", function () {
				$(".ui-dialog-buttonset .ui-button:first-child")[tog(!$(this).val())]("weak");
				$(".ui-dialog-buttonset .ui-button:last-child")[tog($(this).val())]("weak");
				updateSelectValuesFunc($(this).val());
			});

			function tog(v) { return v ? 'addClass' : 'removeClass'; }
			$(document).on('input change paste keyup', '.clearable', function () {
				$(this)[tog(this.value)]('x');
				
			}).on('mousemove', '.x', function (e) {
				$(this)[tog(this.offsetWidth - 18 < e.clientX - this.getBoundingClientRect().left)]('onX');
			}).on('touchstart click', '.onX', function (ev) {
				ev.preventDefault();
				$(this).removeClass('x onX').val('').change();
			});

			$("#autocompleteText").trigger('input');
		});
    
});