﻿FC.DataContext = FC.DataContext || {};

FC.DataContext.Project =
{
	setProject: function (projectId, onSuccess, onFail) {
		FC.Utils.runAjax({
			url: FC.Utils.getControllerUrl("ProjectApi/SetCurrentProject"),
			type: "POST",
			data: {
				projectId: projectId
			},
			beforeSend: FC.Utils.beforeAjaxSend,
			onSuccess: onSuccess,
			onFail: onFail
		});
	},

	getProjects: function (onSuccess, onFail) {
		FC.Utils.runAjax({
			url: FC.Utils.getControllerUrl("ProjectApi/GetProjects"),
			type: "GET",
			beforeSend: FC.Utils.beforeAjaxSend,
			onSuccess: onSuccess,
			onFail: onFail
		});		
	},


	/**
	 * Сохранение режима автоматического взятия
	 * @param {} projectId 
	 * @param {} modeValue boolean
	 * @param {} onSuccess 
	 * @param {} onFail 
	 * @returns {} 
	 */
	setAutoGetTask: function (projectId, modeValue, onSuccess, onFail) {
		FC.Utils.runAjax({
			url: FC.Utils.getControllerUrl("UserSettings/SetAutoGetTask"),
			type: "POST",
			data: {
				projectId: projectId,
				value: modeValue
			},
			beforeSend: FC.Utils.beforeAjaxSend,
			onSuccess: onSuccess,
			onFail: onFail
		});
	},
};