﻿FC.DataContext = FC.DataContext || {};

FC.DataContext.Role =
{
	getRoles: function (projectId, onSuccess, onFail) {
		FC.Utils.runAjax({
			url: FC.Utils.getControllerUrl("Role/GetRoles"),
			type: "GET",
			data: {
				projectId: projectId
			},
			beforeSend: FC.Utils.beforeAjaxSend,
			onSuccess: onSuccess,
			onFail: onFail
		});
	},

	hasAnyPermission: function (permission, onSuccess, onFail) {
		FC.Utils.runAjax({
			url: FC.Utils.getControllerUrl("Role/HasAnyPermission"),
			type: "GET",
			data: {
				projectId: FC.SessionInfo.ProjectID,
				roleId: FC.SessionInfo.RoleID,
				permissions: permission
			},
			beforeSend: FC.Utils.beforeAjaxSend,
			onSuccess: onSuccess,
			onFail: onFail
		});
	},

	getAllowedActions: function (onSuccess, onFail) {
		FC.Utils.runAjax({
			url: FC.Utils.getControllerUrl("Role/AllowedActions"),
			type: "GET",
			data: {
				projectId: FC.SessionInfo.ProjectID,
				roleId: FC.SessionInfo.RoleID
			},
			beforeSend: FC.Utils.beforeAjaxSend,
			onSuccess: onSuccess,
			onFail: onFail
		});
	},

	permissions: {

		/// Нет разрешений.
		None: 0x00000000,

		/// Скрытая роль, недоступная для пользователей.
		IsHidden: 0x00000001,

		/// Выключенная роль. Не отображается в списке ролей при входе на станцию.
		IsDisabled: 0x00000002,

		/// Возможна работа только со своими собственными пакетами,
		/// например, оператор фронт-офиса.
		AccessToOwnBatchesOnly: 0x00000010,

		/// Просмотр списка пакетов (только чтение).
		BatchListBrowsing: 0x00000100,

		/// Создание и удаление пакетов.
		BatchCreation: 0x00000200,

		/// Изменение состава пакета (добавление, удаление и перемещение документов и страниц).
		BatchModification: 0x00000400,

		/// Изменение разметки документов и наложение определений документов и секций.
		DocumentLayoutModification: 0x00000800,

		/// Редактирование содержимого документа.
		DocumentDataModification: 0x00001000,

		/// Создание новых заданий.
		TaskCreation: 0x00010000,

		/// Возможность отложить задание.
		TaskPostponement: 0x00020000,

		/// Просмотр очереди заданий (возможность взять любое задание из очереди,
		/// а не только первое).
		TaskQueueBrowsing: 0x00040000,

		/// Возможность взять чужую задачу (отложенную или назначенную другому пользователю).
		TaskOwnershipChange: 0x00080000,

		/// Возможность посылки заданий на любую стадию
		/// без учета ограничений маршрутизации.
		RoutingIgnoring: 0x00100000,

		/// Возможность изменения приоритета.
		PriorityChange: 0x00200000
	}
};