﻿FC.DataContext = FC.DataContext || {};

FC.DataContext.Template =
{
	getCustomForm: function (projectId, templateId, templateVersion, onSuccess) {
		if (!projectId || !templateId || !templateVersion) {
			return;
		}

		$.ajax({
			url: FC.Utils.getControllerUrl("CustomForm/GetCustomForm"),
			type: "GET",
			data: {
				projectId: projectId,
				templateId: templateId,
				templateVersion: templateVersion
			},
			xhrFields: {
				withCredentials: true
			},
			beforeSend: FC.Utils.beforeAjaxSend,
			dataType: "json",
			success: function (result) {
				if (result.Error) {
					FC.Utils.HandleServerError(result.Error);
					return;
				}

				if (onSuccess) {
					onSuccess(result.Result);
				}
			},
			error: function (jqXhr, textStatus, errorThrown) {
				FC.Utils.HandleJqueryError(jqXhr, textStatus, errorThrown);
			}
		});
	},

	getDocumentDefinition: function (templateId, templateVersion, onSuccess) {
		$.ajax({
			url: FC.Utils.getControllerUrl("Definitions/GetDefinitionFullInfo"),
			type: "GET",
			data: {
				projectId: FC.SessionInfo.ProjectID,
				templateId: templateId,
				templateVersion: templateVersion
			},
			xhrFields: {
				withCredentials: true
			},
			beforeSend: FC.Utils.beforeAjaxSend,
			dataType: "json",
			success: function (result) {
				if (result.Error) {
					FC.Utils.HandleServerError(result.Error);
					return;
				}

				if (onSuccess) {
					onSuccess(result.Result);
				}
			},
			error: function (jqXhr, textStatus, errorThrown) {
				FC.Utils.HandleJqueryError(jqXhr, textStatus, errorThrown);
			}
		});
	},

	getAllDocumentDefinitions: function (batchId, onSuccess) {
		$.ajax({
			url: FC.Utils.getControllerUrl("Definitions/GetDocumentDefinitions"),
			type: "GET",
			data: {
				projectId: FC.SessionInfo.ProjectID,
				batchId: batchId
			},
			dataType: "json",
			xhrFields: {
				withCredentials: true
			},
			beforeSend: FC.Utils.beforeAjaxSend,
			success: function (result) {
				if (result.Error) {
					FC.Utils.HandleServerError(result.Error);
					return;
				}

				if (onSuccess) {
					onSuccess(result.Result);
				}
			},
			error: function (jqXhr, textStatus, errorThrown) {
				FC.Utils.HandleJqueryError(jqXhr, textStatus, errorThrown);
			}
		});
	}
};