﻿(function () {
	hotkeys.filter = function (event) {
		// если открыто окно About - блокируем все хоткеи
		if (aboutWindowIsOpen)
			return false;
		return true;
	}
	var parts = {
		BatchEditor: 1,
		DocumentEditor: 2,
		FormEditor: 3,
		ErrorsEditor: 4,
		DbLookUp: 5
	};
	var partUnderMouse = null;
	var activePart = null;

	$(document).ready(function () {
		$("#panel_0").mouseover(function () {
			partUnderMouse = parts.BatchEditor;
		});

		$("#panel_1").mouseover(function (e) {
			partUnderMouse = parts.DocumentEditor;
		});

		$("#documentEditor_errorView").mouseover(function () {
			partUnderMouse = parts.ErrorsEditor;
		});

		$(".documentEditor_formViewer_body_container").mouseover(function () {
			partUnderMouse = parts.FormEditor;
		});

		$("#panel_2 .batchLayout__panel__head").mouseover(function () {
			partUnderMouse = parts.FormEditor;
		});

		$(".documentEditor_formViewer_body_container").mousedown(function () {
			activePart = parts.FormEditor;
		});

		$(".documentEditor_formViewer_body_container").focusin(function () {
			activePart = parts.FormEditor;
		});

		$("#documentEditor_errorView").mousedown(function () {
			activePart = parts.ErrorsEditor;
		});
		$("#documentEditor__dblookup").mousedown(function () {
			activePart = parts.DbLookUp;
		});

		$("#panel_0").mousedown(function () {
			activePart = parts.BatchEditor;
		});

		$("#panel_1").mousedown(function () {
			activePart = parts.DocumentEditor;
		});
	});


	hotkeys('ctrl+q',
		function (event, handler) {
			event.preventDefault();
			if (window.batchApp.extensions.hasChanges()) {
				window.Layouts.ModelLoader.viewModel().applyAllChanges();
			}
		});

	hotkeys('alt+del',
		function (event, handler) {
			event.preventDefault();
			FC.Viewmodels.BatchEditorExtention.removeTemplate();
		});

	var tryProcessSelectedFieldHotKeys = function (e) {

		if (!window.batchLayoutViewModel.rightFrameVisible() ||
			activePart !== parts.FormEditor &&
			activePart !== parts.ErrorsEditor &&
			activePart !== parts.DocumentEditor) {
			return false;
		}

		var fieldsPanel = window.batchLayout.batchLayoutViewModel.UserEditor.fieldsViewmodel;
		var selectedField = fieldsPanel.selectedField();
		if (!selectedField) {
			return false;
		}

		var selectedFieldVm = fieldsPanel.getFieldViewmodel(selectedField);
		if (!selectedFieldVm) {
			return false;
		}

		var selectedFieldElement = document.getElementById(selectedFieldVm.DomId);

		// tab
		if (hotkeys.isPressed(9)) {
			if (!selectedFieldElement) {
				fieldsPanel.scrollToField(selectedField);
			}

			// по табу переходим к следующему полю, по shift-tab - к предыдущему
			var direction = hotkeys.shift ? -1 : 1;
			FC.Viewmodels.FormNavigation.navigateToNextField(direction, selectedFieldVm.DomId);
			return true;
		}

		// enter
		if (hotkeys.isPressed(13)) {

			if (hotkeys.shift) {
				return false;
			}

			if (!selectedFieldElement) {
				fieldsPanel.scrollToField(selectedField);
			}

			// верифицируем поле и переходим на следующее
			selectedFieldVm.rewritableFunctions.verify();
			return true;
		}

		// esc
		if (hotkeys.isPressed(27)) {
			// по esc снимаем с поля выделение
			if (selectedFieldElement) {
				selectedFieldElement.blur();
			}

			fieldsPanel.selectedField(null);

			// оповестим редактор документа, какое поле выбрано - чтобы потом не искать
			Sammy.apps.body.trigger('docEditor_fieldSelected', { field: null });
			return true;
		}

		if (selectedFieldElement && selectedFieldVm.readOnly() && !(hotkeys.isPressed(39) || hotkeys.isPressed(37) || hotkeys.isPressed(38) || hotkeys.isPressed(40))) {
			e.preventDefault();
		}

		return false;
	};

	hotkeys('*',
		function (e) {
			var rightFrameVisible = window.batchLayoutViewModel.rightFrameVisible();
			var centerFrameVisible = window.batchLayoutViewModel.centerFrameVisible();
			var leftFrameVisible = window.batchLayoutViewModel.leftFrameVisible();

			if ($(e.target).parents('.documentEditor__dblookup').length > 0) {
				return true;
			}


			//Подтверждение классификации  Ctrl+ Enter
			if (hotkeys.isPressed(13)) {

				if (e.ctrlKey) {
					FC.Viewmodels.BatchEditorExtention.confirmPageSection();
					FC.Viewmodels.BatchEditorExtention.confirmDocumentDefinition();
					return false;
				}
			}

			if (tryProcessSelectedFieldHotKeys(e)) {
				return false;
			}

			// ctrl + > поворот изображения по часовой
			if (leftFrameVisible && hotkeys.ctrl && hotkeys.isPressed(190)) {
				e.preventDefault();
				FC.Viewmodels.BatchEditorExtention.rotatePage(90);
				return false;
			}

			// ctrl + < поворот изображения против часовой
			if (leftFrameVisible && hotkeys.ctrl && hotkeys.isPressed(188)) {
				e.preventDefault();
				FC.Viewmodels.BatchEditorExtention.rotatePage(270);
				return false;
			}


			// ctrl + \  режим рисования вертикального сепаратора
			if (centerFrameVisible && hotkeys.ctrl && hotkeys.isPressed(220)) {
				e.preventDefault();
				window.batchApp.extensions.onCommandExecute(window.batchLayoutViewModel.proxy, 1);
				return false;
			}


			// Shift + \  режим рисования горизонтального сепаратора
			if (centerFrameVisible && hotkeys.shift && hotkeys.isPressed(220)) {
				e.preventDefault();
				window.batchApp.extensions.onCommandExecute(window.batchLayoutViewModel.proxy, 2);
				return false;
			}


			// alt + \  режим удаления сепаратора
			if (centerFrameVisible && hotkeys.alt && hotkeys.isPressed(220)) {
				e.preventDefault();
				window.batchApp.extensions.onCommandExecute(window.batchLayoutViewModel.proxy, 0);
				return false;
			}


			// F6 следующая / предыдущая ошибка
			if (rightFrameVisible && hotkeys.isPressed(117)) {
				e.preventDefault();
				if (hotkeys.shift) {
					window.batchLayout.batchLayoutViewModel.UserEditor.errorsViewmodel.previousError();
				} else {
					window.batchLayout.batchLayoutViewModel.UserEditor.errorsViewmodel.nextError();
				}
				return false;
			}

			// F7 следующий / предыдущий документ с ошибкой классификации
			if (leftFrameVisible && hotkeys.isPressed(118)) {
				e.preventDefault();
				if (hotkeys.shift) {
					window.batchApp.extensions.navigateToPreviousClassificationError();
				} else {
					window.batchApp.extensions.navigateToNextClassificationError();
				}
				return false;
			}

			// F9 следующий / предыдущий документ с ошибкой
			if (leftFrameVisible && hotkeys.isPressed(120)) {
				e.preventDefault();
				if (hotkeys.shift) {
					window.batchApp.extensions.navigateToPreviousError();
				} else {
					window.batchApp.extensions.navigateToNextError();
				}
				return false;
			}

			// F8 следующее / предыдущее поле с неуверенными символами
			if (rightFrameVisible && hotkeys.isPressed(119)) {
				e.preventDefault();
				if (hotkeys.shift) {
					window.batchLayout.batchLayoutViewModel.UserEditor.errorsViewmodel.goToPreviousUncertainSymbolField();
				} else {
					window.batchLayout.batchLayoutViewModel.UserEditor.errorsViewmodel.goToNextUncertainSymbolField();
				}
				return false;
			}

			// F4 следующий объект верификации
			if (rightFrameVisible && hotkeys.isPressed(115)) {
				e.preventDefault();
				if (hotkeys.shift) {
					window.batchLayout.batchLayoutViewModel.UserEditor.errorsViewmodel.goToPreviousFieldNeedAttention();
				} else {
					window.batchLayout.batchLayoutViewModel.UserEditor.errorsViewmodel.goToNextFieldNeedAttention();
				}
				return false;
			}



			// F2 режим работы с регионами
			if (centerFrameVisible && hotkeys.isPressed(113)) {
				event.preventDefault();
				var pages = window.batchLayout.batchLayoutViewModel.UserEditor.regionsViewmodel.pages();
				if (pages && pages.length > 0) {
					//F2 + Del (удаление региона)
					if (hotkeys.isPressed(46)) {
						$.each(pages,
							function (pageInd, page) {
								$.each(page.selectedRegions(),
									function (regionIndex, region) {
										if (!(region instanceof FC.Viewmodels.DocumentEditor.TextRegionViewModel) && region) {
											page.deleteRegion(region);
										}
									});
							});
					}

					if (hotkeys.isPressed(39) || hotkeys.isPressed(37) || hotkeys.isPressed(38) || hotkeys.isPressed(40)) {
						var endPoint = { x: 0, y: 0 };
						if (hotkeys.isPressed(39)) {
							endPoint.x = 5;
						}
						if (hotkeys.isPressed(37)) {
							endPoint.x = -5;
						}
						if (hotkeys.isPressed(38)) {
							endPoint.y = -5;
						}
						if (hotkeys.isPressed(40)) {
							endPoint.y = 5;
						}
						$.each(pages,
							function (pageInd, page) {

								$.each(page.selectedRegions(),
									function (regionIndex, region) {
										if (!(region instanceof FC.Viewmodels.DocumentEditor.TextRegionViewModel) && !(region instanceof FC.Viewmodels.DocumentEditor.CellRegionViewModel)) {

											region.moveRegion(endPoint.x, endPoint.y);
											region.updateText();
											region.page.draw();
										}
									});
							});
					}

				}
				return false;
			}

			// esc
			if (centerFrameVisible && hotkeys.isPressed(27) && activePart === parts.DocumentEditor) {
				var docEditor = window.batchLayout.batchLayoutViewModel.DocumentEditor();
				var needRedraw = false;
				if (docEditor.extender.horizontalSeparatorDrawActivated()) {
					docEditor.extender.horizontalSeparatorDrawActivated(false);
					needRedraw = true;
				}

				if (docEditor.extender.verticalSeparatorDrawActivated()) {
					docEditor.extender.verticalSeparatorDrawActivated(false);
					needRedraw = true;
				}

				if (docEditor.extender.deleteSeparatorActivated()) {
					docEditor.extender.deleteSeparatorActivated(false);
					needRedraw = true;
				}

				if (needRedraw) {
					var pages = window.batchLayout.batchLayoutViewModel.UserEditor.regionsViewmodel.pages();
					if (pages && pages.length > 0) {
						$.each(pages, function (pageInd, page) {
							page.draw();
						});
					}
				}
			}

			if ($(document.activeElement).parents('#formViewer_body').length === 0 &&
				!($(document.activeElement).closest('#keyboardShortcuts__main').length > 0)) {
				var batchEditorVerticalSlider = window.batchLayout.batchLayoutViewModel.BatchEditor.verticalSlider;
				var errorsVerticalScroll =
					window.batchLayout.batchLayoutViewModel.UserEditor.errorsViewmodel.scroller.errorVerticalScroll;
				var formEditorVerticalScroller = window.batchLayout.batchLayoutViewModel.UserEditor.fieldsViewmodel.formVerticalScroll;
				var selectingInstances = window.batchLayout.batchLayoutViewModel.UserEditor.fieldsViewmodel.selectingInstances();
				//Стрелки вверх вниз для трех панелей
				if (hotkeys.isPressed(38) || hotkeys.isPressed(40)) {
					switch (partUnderMouse) {
						case parts.BatchEditor:
							e.preventDefault();
							if (hotkeys.isPressed(38)) {
								batchEditorVerticalSlider.decreaseValue();
							} else {
								batchEditorVerticalSlider.increaseValue();
							}
							break;
						case parts.DocumentEditor:
							e.preventDefault();
							if (hotkeys.isPressed(38)) {
								window.batchLayout.batchLayoutViewModel.DocumentEditor().hotKeys.verticalSliderDecreaseValue();
							} else {
								window.batchLayout.batchLayoutViewModel.DocumentEditor().hotKeys.verticalSliderIncreaseValue();
							}
							break;

						case parts.ErrorsEditor:
							e.preventDefault();
							if (hotkeys.isPressed(38)) {
								errorsVerticalScroll.decreaseValue();
							} else {
								errorsVerticalScroll.increaseValue();
							}
							break;
						case parts.FormEditor:
							if (!selectingInstances) {
								e.preventDefault();
								if (hotkeys.isPressed(38)) {
									formEditorVerticalScroller.decreaseValue();
								} else {
									formEditorVerticalScroller.increaseValue();
								}
							}
							break;
					}
				}
				//Стрелки вправо влево для трех панелей
				if (hotkeys.isPressed(37) || hotkeys.isPressed(39)) {
					switch (partUnderMouse) {
						case parts.DocumentEditor:
							e.preventDefault();
							if (hotkeys.isPressed(37)) {
								window.batchLayout.batchLayoutViewModel.DocumentEditor().hotKeys.horizontalSliderDecreaseValue();
							} else {
								window.batchLayout.batchLayoutViewModel.DocumentEditor().hotKeys.horizontalSliderIncreaseValue();
							}
							break;

						case parts.FormEditor:
							e.preventDefault();
							if (hotkeys.isPressed(37)) {
								window.batchLayout.batchLayoutViewModel.UserEditor.fieldsViewmodel.formHorizontalScroll.decreaseValue();
							} else {
								window.batchLayout.batchLayoutViewModel.UserEditor.fieldsViewmodel.formHorizontalScroll.increaseValue();
							}
							break;
					}
				}

				//HOME/END для трех панелей
				if (hotkeys.isPressed(35) || hotkeys.isPressed(36)) {
					switch (partUnderMouse) {
						case parts.BatchEditor:
							e.preventDefault();
							if (hotkeys.isPressed(36)) {
								batchEditorVerticalSlider.home();
							} else {
								batchEditorVerticalSlider.end();
							}
							break;

						case parts.DocumentEditor:
							e.preventDefault();
							if (hotkeys.isPressed(36)) {
								window.batchLayout.batchLayoutViewModel.DocumentEditor().hotKeys.verticalSliderHome();
							} else {
								window.batchLayout.batchLayoutViewModel.DocumentEditor().hotKeys.verticalSliderEnd();
							}
							break;

						case parts.ErrorsEditor:
							e.preventDefault();
							if (hotkeys.isPressed(36)) {
								errorsVerticalScroll.home();
							} else {
								errorsVerticalScroll.end();
							}
							break;

						case parts.FormEditor:
							e.preventDefault();
							if (hotkeys.isPressed(36)) {
								formEditorVerticalScroller.home();
							} else {
								formEditorVerticalScroller.end();
							}
							break;
					}
				}

				//Page up/down для трех панелей
				if (hotkeys.isPressed(33) || hotkeys.isPressed(34)) {
					switch (partUnderMouse) {
						case parts.BatchEditor:
							e.preventDefault();
							if (hotkeys.isPressed(33)) {
								batchEditorVerticalSlider.pageUp();
							} else {
								batchEditorVerticalSlider.pageDown();
							}
							break;
						case parts.DocumentEditor:
							e.preventDefault();
							if (hotkeys.isPressed(33)) {
								window.batchLayout.batchLayoutViewModel.DocumentEditor().hotKeys.verticalSliderPageUp();
							} else {
								window.batchLayout.batchLayoutViewModel.DocumentEditor().hotKeys.verticalSliderPageDown();
							}
							break;
						case parts.ErrorsEditor:
							e.preventDefault();
							if (hotkeys.isPressed(33)) {
								errorsVerticalScroll.pageUp();
							} else {
								errorsVerticalScroll.pageDown();
							}
							break;
						case parts.FormEditor:
							e.preventDefault();
							if (hotkeys.isPressed(33)) {
								formEditorVerticalScroller.pageUp();
							} else {
								formEditorVerticalScroller.pageDown();
							}
							break;
					}
				}
			}

			// ALT + цифра  переклчение фильтров
			var pressedKeycodes = hotkeys.getPressedKeyCodes();
			if (rightFrameVisible && e.altKey) {
				for (var i = 0; i < pressedKeycodes.length; i++) {
					if (pressedKeycodes[i] >= 49 && pressedKeycodes[i] < 58) {
						var pressedNumber = pressedKeycodes[i] - 49;
						var vals = window.batchLayout.batchLayoutViewModel.UserEditor.errorsViewmodel.errorViewModeData().values();
						var enabledIndex = -1;
						for (var j = 0; j < vals.length; j++) {
							if (!vals[j].hidden()) {
								enabledIndex++;
							}

							if (enabledIndex === pressedNumber) {
								vals[j].onClick();
							}
						}

					}
				}
				return false;
			}

		});

	hotkeys('alt+g',
		function (event, handler) {
			event.preventDefault();
			window.batchApp.extensions.autoGetMode(!window.batchApp.extensions.autoGetMode());
		});

	hotkeys('ctrl+j',
		function (event, handler) {
			event.preventDefault();
			window.batchApp.extensions.rejectTask();
		});


	hotkeys('ctrl+alt+l',
		function (event, handler) {
			event.preventDefault();
			window.batchApp.extensions.postponeTask();
		});

	hotkeys('ctrl+alt+q',
		function (event, handler) {
			event.preventDefault();
			window.batchApp.extensions.sendToStageTask();
		});


	hotkeys('ctrl+shift+x',
		function (event, handler) {
			event.preventDefault();
			window.batchApp.extensions.sendToExceptionTask();
		});

	hotkeys('ctrl+alt+p',
		function (event, handler) {
			event.preventDefault();
			window.batchApp.extensions.sendToRescanTask();
		});

	hotkeys('ctrl+l',
		function (event, handler) {
			event.preventDefault();
			window.batchApp.extensions.completeTask();
		});

	hotkeys('ctrl+r',
		function (event, handler) {
			event.preventDefault();
			window.batchApp.extensions.recognizeSelectedDocuments();
		});

	hotkeys('ctrl+d',
		function (event, handler) {
			event.preventDefault();
			window.batchApp.extensions.gotoNextDocument();
		});

	hotkeys('ctrl+shift+d',
		function (event, handler) {
			event.preventDefault();
			window.batchApp.extensions.gotoPreviousDocument();
		});


	hotkeys('ctrl+shift+s',
		function (event, handler) {
			event.preventDefault();
			if (window.batchLayout.batchLayoutViewModel.UserEditor.documentHasChanges()) {
				window.batchLayout.batchLayoutViewModel.UserEditor.checkRules(false, true);
			}
		});


})();