﻿FC.Pages.StageSelector = function (showCreateTask, onSuccess) {
	var self = this;

	$.extend(self, new FC.DialogBase(onSuccess, null, null, false, FC.Environment.Headless, false, ko.observable(false), false, "sendToStageDialogue"));

	self.showCreateTask = ko.observable(showCreateTask);

	self.selectedPriority = ko.observable(0);

	self.createTask = ko.observable(true);

	self.createTaskEnabled = ko.observable(true);

	self.taskParamsVisible = ko.computed(function () { return !self.showCreateTask() || self.createTask(); });

	self.stages = ko.observableArray([]);

	self.selectedStage = ko.observable(null);

	self.currentBatchId = ko.observable(null);

	self.users = ko.observableArray([]);

	self.selectedUser = ko.observable(null);

	self.comment = ko.observable('');

	const uniqBatchId = new Set();

	self.selectedStage.subscribe(function (stage) {
		self.createTaskEnabled(true);
		self.createTask(true);

		if (self.stages().length > 0) {
			if (self.taskParamsVisible()) {
				if (!uniqBatchId.has(self.currentBatchId())) {
					uniqBatchId.add(self.currentBatchId())
					self.updateUsers(self.currentBatchId(), stage ? stage.Id : 0);
				}
			}

			if (self.showCreateTask() && stage) {
				switch (stage.Id) {
					case 800:
					case 900:
						self.createTaskEnabled(false);
						self.createTask(false);
						break;
					case 150:
						self.createTaskEnabled(false);
						self.createTask(true);
						break;
					default: break;
				}
			}
		} else {
			self.users([]);
		}
	});

	self.stagesAreUpdating = false;
	self.usersAreUpdating = false;

	self.updateStages = function (batchId) {
		self.stagesAreUpdating = true;
		self.disableMainAction(self.stagesAreUpdating || self.usersAreUpdating);
		self.currentBatchId(batchId);

		FC.DataContext.Batch.getBatchStages(batchId,
			function (stages) {
				self.stages(stages);
				if (!self.selectedStage() && stages.length > 0) {
					self.selectedStage(stages[0]);
				}

				self.stagesAreUpdating = false;
				self.disableMainAction(self.stagesAreUpdating || self.usersAreUpdating);
			});
	};

	self.updateUsers = function (batchId, stageId) {
		self.usersAreUpdating = true;
		self.disableMainAction(true);
		FC.DataContext.Batch.getBatchUsers(batchId,
			stageId,
			function (users) {
				self.users(users);
				if (!self.selectedUser() && users.length > 0) {
					self.selectedUser(users[0].Id);
				}

				self.usersAreUpdating = false;
				self.disableMainAction(self.stagesAreUpdating || self.usersAreUpdating);
			});
	};
};