﻿// TODO: разобраться, используется ли где-нибудь этот код
FC.Pages.VerifyPage = function (batchLayout, dependencies, taskDocuments) {
	var unloadEventName = 'onpagehide' in window ? 'pagehide' : 'unload';

	var self = this;
	self.batchLayout = batchLayout;

	var eventManager = dependencies.eventManager;

	self.ApplyChangesText = ko.observable(FC.Environment.Localization.GlobalResources.ApplyChangesButton);
	self.BatchId = ko.observable(0);
	self.taskId = ko.observable(0);
	self.projectId = ko.observable(0);
	self.stageId = ko.observable(0);

	self.documentsMoved = ko.observable(false);
	self.Processing = ko.observable(false);
	self.ProcessingMessage = ko.observable('');
	self.TimeoutId = null;

	self.documentLoading = ko.observable(false);
	self.documentLoaderCss = ko.observable({});

	eventManager.bind('needRecognize', function () {
		FC.Pages.VerifyPage.showNeedRecognizeLocker();
	});

	self.PreviousErrorImageAlt = ko.observable(FC.Environment.Localization.GlobalResources.GoToPreviousError);
	self.NextErrorImageAlt = ko.observable(FC.Environment.Localization.GlobalResources.GoToNextError);

	var processingFinishedDisabled = false;
	eventManager.bind('processingStarted', function (e, data) {
		var text = '';
		if (data && data.hasOwnProperty('text')) {
			text = data.text;
		}
		if (self.TimeoutId) {
			clearInterval(self.TimeoutId);
		}
		self.TimeoutId = setInterval(function () {
			self.Processing(false);
			FC.Utils.Error.Show(FC.Environment.Localization.GlobalResources.CheckRulesFailedTimeout);
		}, FC.Environment.RuleCheckingTimeout);

		self.ProcessingMessage(text);
		self.Processing(true);
	});

	eventManager.bind('processingFinished', function () {
		if (processingFinishedDisabled) return;

		if (self.TimeoutId !== null) {
			clearInterval(self.TimeoutId);
			self.TimeoutId = null;
		}

		self.batchLayout.hideTwoPanelsLocker();
		var selectedDocument = self.batchLayout.SelectedDocument();
		if (selectedDocument && (selectedDocument.Status() === FC.BatchEditor.Document.Status.Normal ||
			selectedDocument.Status() === FC.BatchEditor.Document.Status.RecognizeFinished ||
			selectedDocument.Status() === FC.BatchEditor.Document.Status.CheckRulesFinished)) {
			FC.Pages.VerifyPage.hideRerecognizeLocker();
		}

		// TODO придумать как не убирать занавеску, костыль чтобы как-то починить перед выпуском
		if (self.ProcessingMessage() !== FC.Environment.Localization.GlobalResources.ClosingDocument) {
			self.Processing(false);
		}
	});

	eventManager.bind('documentLoadingStarted', function () {
		self.documentLoading(true);
		self.documentLoaderCss({
			width: (self.batchLayout.centerFrameVisible() ? self.batchLayout.centerPanelWidth() : 0) +
				(self.batchLayout.rightFrameVisible() ? panelsLayoutModel.rightPanelWidth() : 0) +
				(panelsLayoutModel.rightFrameVisible() && panelsLayoutModel.centerFrameVisible() ? 5 : 0),
			height: $('#MainHeader')
		});
	});

	self.applyAllChanges = function (e, data) {
		eventManager.trigger('processingStarted',
			{ text: FC.Environment.Localization.GlobalResources.CheckingAssemblingErrors });
		// сохраняем изменения в документ
		var userEditor = self.batchLayout.UserEditor;
		var doc = userEditor ? userEditor.selectedDocument() : null;
		var selectedDocIndex = doc && doc.Id() < 0
			? window.batchLayoutViewModel.Documents().indexOf(userEditor.selectedDocument())
			: -1;

		var onApplied = function () {

			(window.batchLayoutViewModel.Documents() || []).forEach(function(doc) {
				doc.updateTemplate(false);
			});
			if (userEditor && doc) {
				if (selectedDocIndex > -1 && window.batchLayoutViewModel.Documents().length > selectedDocIndex) {
					doc = window.batchLayoutViewModel.Documents()[selectedDocIndex];
					userEditor.selectedDocument(doc);
				}

				//doc.checkRulesStarted(false);
				userEditor.updateDocumentInfo(doc,
					false,
					function() {
						processingFinishedDisabled = false;
						eventManager.trigger('processingFinished');
					});
			} else {
				if (data) {
					data.OnApplied();
				}
				
				processingFinishedDisabled = false;
				eventManager.trigger('processingFinished');
			}
		};
		processingFinishedDisabled = true;
		var selectedDocument = self.batchLayout.SelectedDocument();
		var currentDocumentHasChanges = self.batchLayout.UserEditor && self.batchLayout.UserEditor.documentHasChanges();

		if (!userEditor ||
			!self.batchLayout.UserEditor.checkRules(selectedDocument && selectedDocument.Status() !== FC.BatchEditor.Document.Status.NeedRecognize,
				false,
				function () {
					eventManager.trigger('processingStarted',
						{ text: FC.Environment.Localization.GlobalResources.CheckingAssemblingErrors });

					self.ApplyChanges(onApplied, currentDocumentHasChanges);
				})) {
			self.ApplyChanges(onApplied, currentDocumentHasChanges);
		}
	};

	eventManager.bind('applyChanges', self.applyAllChanges);

	var beforeunload = function (e) {
		(e || window.event).returnValue = FC.Environment.Localization.GlobalResources.UnloadPrompt;

		return FC.Environment.Localization.GlobalResources.UnloadPrompt;
	};

	var unload = function () {
		FC.DataContext.Server.closeSessionOnUnload();
	};

	self.checkDocumentSets = function (taskdocs) {
		for (var i = 0; i < taskdocs.length; i++) {
			for (var j = 0; j < taskdocs[i].ChildNodes.length; j++) {
				if (!taskdocs[i].ChildNodes[j]) {
					continue;
				}

				if (taskdocs[i].ChildNodes[j].hasOwnProperty("ChildNodes")) {
					// комплекты
					self.SenderToExceptions().comment(FC.Environment.Localization.GlobalResources.HaveToSendToExceptions_Comment);
					self.Processing(false);
					self.sendToExceptionsNoEscape(true);
					self.SendToExceptions();
					return true;
				}
			}
		}

		return false;
	}

	self.onTaskDocumentsLoad = function (taskDocuments) {
		if (taskDocuments) {
			self.projectId(taskDocuments.ProjectId);
			self.stageId(taskDocuments.StageId);
			self.taskId(taskDocuments.TaskId);

			if (taskDocuments.Documents && self.checkDocumentSets(taskDocuments.Documents)) {
				// комплекты
				return;
			}

			self.canRescan(taskDocuments.CanRescan);
			self.canClose(taskDocuments.CanClose);
			self.canSend(taskDocuments.CanSendToStage);
			self.canSendToExceptions(taskDocuments.CanSendToExceptions);
			self.canPostpone(taskDocuments.CanPostpone);
			self.canReject(taskDocuments.CanReject);
			self.TaskLoaded(true);
			self.ApplyChangesText(FC.Environment.Localization.GlobalResources.ApplyChangesButton);

			window.addEventListener(unloadEventName, unload);
			window.addEventListener('beforeunload', beforeunload);

			self.batchLayout.Documents(
				$.map(taskDocuments.Documents, function (item) {
					item.TaskId = taskDocuments.TaskId;
					return new FC.BatchEditor.Document(item);
				}));

			self.BatchId(taskDocuments.Documents[0].BatchId);

			self.updateDocumentsAndPages();

			var documents = self.batchLayout.Documents();
			if (documents.length > 0) {

				self.batchLayout.SelectedDocument(documents[0]);
				for (var i = 1; i < documents.length; i++) {
					self.batchLayout.BatchEditor.viewModelInitializers[documents[i]._id] = function (viewModel) {
						viewModel.toogleDetails();
					};
				}
				self.batchLayout.BatchEditor.currentCollapseState(1);
				eventManager.trigger('showDocumentEditor');

				var onGetTemplatesComplete = function () {
					FC.Viewmodels.BatchEditorExtention.docTemplates =
						FC.Viewmodels.documentDefinitionsContext.documentDefinitions();

					self.batchLayout.BatchEditor.updateContextMenu();
				};

				FC.Viewmodels.documentDefinitionsContext.loadDocumentDefinitions(
					taskDocuments.Documents[0].BatchId,
					dependencies.templateDataContext,
					onGetTemplatesComplete);

				$(window).resize();
			} else {
				self.batchLayout.leftFrameVisible(true);
				self.batchLayout.centerFrameVisible(false);
				self.batchLayout.rightFrameVisible(false);
			}


		}
	};

	self.updateDocumentsAndPages = function () {
		var docs = self.batchLayout.Documents();

		var proxy = self.batchLayout.proxy;

		var allPages = docs.map(function (doc) {
			return doc.ChildNodes().map(function (page, index) {
				var pageInfo = {
					id: page.Id(),
					imageWidth: page.Width(),
					imageHeight: page.Height(),
					title: (index + 1).toString(),
					parentDocumentId: doc.Id(),
					hasColorImage: page.HasColorImage(),
					version: page.Version(),
					rotation: page.Rotation()
				};

				pageInfo.imageUri = dependencies.batchDataContext.getPageUrl(pageInfo,
					FC.BatchEditor.batchEditorDataContext.ImageLoadMode() && pageInfo.hasColorImage);

				return pageInfo;
			});
		});

		var action = proxy.batchActionCreators.updateDocumentsAndPages(
			docs.map(function (document) {
				return {
					id: document.Id(),
					pagesIds: document.ChildNodes().map(function (page) { return page.Id(); })
				};
			}),
			[].concat.apply([], allPages) // Линеаризация allPages
		);

		proxy.store.dispatch(action);
		window.batchLayoutComponent.store.dispatch(action);
	};

	ko.computed(function () {
		var doc = self.batchLayout.SelectedDocument();
		if (!doc) {
			return;
		}
		var trigger = doc.ChildNodes().map(function (p) {
			return p.Rotation();
		});

		self.updateDocumentsAndPages();
	}).extend({ deferred: true });

	self.GetCurrentTaskDocuments = function () {
		eventManager.trigger('processingStarted');

		FC.DataContext.Task.getCurrentTaskDocuments(
			self.taskId(),
			function (result) {
				if (result) {
					self.batchLayout.copyDocumentsFrom(result, function (doc) {
						doc.TaskId = self.taskId();
						return new FC.BatchEditor.Document(doc);
					});
				}

				eventManager.trigger('processingFinished');
			});
	};

	self.TaskLoaded = ko.observable(false);

	var getDocsAsJsonAndResetBatchEditor = function (serializeDocumentStatus) {
		var docJson = self.batchLayout.BatchEditor.getDocumentsAsJson(false, serializeDocumentStatus);
		self.batchLayout.BatchEditor.deletedDocuments([]);
		self.documentsMoved(false);
		return docJson;
	};

	var getDocsArray = function (onlyChanged, currentDocumentHasChanges) {
		var deletedDocs = self.batchLayout.BatchEditor.deletedDocuments();
		deletedDocs.forEach(function (doc) { doc.IsDeleted(true) });
		return window.batchLayoutViewModel.Documents()
			.filter(function (d) {
				return self.documentsMoved() || !onlyChanged || d.HasChanges() ||
					(d === self.batchLayout.SelectedDocument() && currentDocumentHasChanges);
			})
			.concat(deletedDocs);
	}

	self.ApplyChanges = function (onApplied, currentDocumentHasChanges) {
		FC.DataContext.Task.applyChanges(getDocsArray(true, currentDocumentHasChanges), self.taskId(), false, function (result) {
			self.batchLayout.BatchEditor.deletedDocuments([]);
			self.documentsMoved(false);
			UndoEngine.CleanStacks();
			if (result) {
				if (!self.checkDocumentSets(result)) {
					self.batchLayout.copyDocumentsFrom(result,
						function(doc) {
							doc.TaskId = self.taskId();
							return new FC.BatchEditor.Document(doc);
						});
				}
			}
			if (onApplied) {
				onApplied();
			}
		});
	};

	self.OnRecognize = function () {
		eventManager.trigger('processingStarted');

		FC.DataContext.Task.recognize(
			getDocsAsJsonAndResetBatchEditor(false),
			self.taskId(),
			function () {
				self.tryLeavePage("FC_Verification_TaskSentToRecognition");
			});
	};

	// Коды типов ошибок
	var ErrorTypes = { RuleError: 0, FormatError: 1, MergeVersionError: 2, UnmatchedRegionError: 3, ErrorInChildDocument: 4 };
	// Серьёзность ошибок
	var ErrorSeverity = { Warning: 0, Error: 1 };

	/*
	 * Подсчитать количество разных ошибок и предупреждений в документе
	 * */
	var getDocErrors = function (document) {
		var assemblyErrorsCount = 0;
		var rulesErrorsCount = 0;
		var requireVerificationCount = 0;
		var warningsCount = 0;
		var regionErrorsCount = 0;

		if (document.Model.AssemblingErrors() && document.Model.AssemblingErrors().length > 0) {
			assemblyErrorsCount += document.Model.AssemblingErrors().length;
		}

		if (document.Model.HasClassificationWarning()) {
			assemblyErrorsCount++;
		}


		if (document.Model.VerificationSymbolsCount()) {
			requireVerificationCount += document.Model.VerificationSymbolsCount();
		}

		var docFormErrors = document.Model.FormErrors();

		if (docFormErrors && docFormErrors.length > 0) {

			for (var i = 0; i < docFormErrors.length; i++) {
				var errorsCount = docFormErrors[i].Count();

				switch (docFormErrors[i].Type()) {
					case ErrorTypes.UnmatchedRegionError:
						regionErrorsCount += errorsCount;
						break;

					case ErrorTypes.RuleError:
					case ErrorTypes.FormatError:
					case ErrorTypes.MergeVersionError:
					case ErrorTypes.ErrorInChildDocument:
						switch (docFormErrors[i].Severity()) {
							case ErrorSeverity.Warning:
								warningsCount += errorsCount;
								break;

							case ErrorSeverity.Error:
								rulesErrorsCount += errorsCount;
								break;
						}
						break;

					default:
						throw new Error("unknown error type: " + docFormErrors[i].Type());
				}
			}
		}

		return {
			assemblyErrorsCount: assemblyErrorsCount,
			rulesErrorsCount: rulesErrorsCount,
			requireVerificationCount: requireVerificationCount,
			warningsCount: warningsCount,
			regionErrorsCount: regionErrorsCount
		};
	};

	var checkErrorsAndSave = function () {

		var firstProblemDocument;

		var errorsCount = {
			assemblyErrors: 0,
			rulesErrors: 0,
			requireVerification: 0,
			warnings: 0,
			regionErrors: 0,
			notRecognizedDocs: 0
		};

		$.each(self.batchLayout.BatchEditor.elements(),
			function (index, document) {
				var docErrors = getDocErrors(document);

				if (docErrors.assemblyErrorsCount + docErrors.rulesErrorsCount + docErrors.requireVerificationCount +
					docErrors.warningsCount + docErrors.regionErrorsCount > 0) {

					if (!firstProblemDocument) {
						firstProblemDocument = document;
					}

					errorsCount.assemblyErrors += docErrors.assemblyErrorsCount;
					errorsCount.rulesErrors += docErrors.rulesErrorsCount;
					errorsCount.requireVerification += docErrors.requireVerificationCount;
					errorsCount.warnings += docErrors.warningsCount;
					errorsCount.regionErrors += docErrors.regionErrorsCount;
				}

				if (document.Model.docNeedRecognize()) {
					errorsCount.notRecognizedDocs++;
				}
			}
		);

		if (firstProblemDocument) {

			var returnToFirstProblemDocument = function () {
				self.batchLayout.UserEditor.errorsViewmodel.multiFieldErrorsSelected(true);
				self.batchLayout.UserEditor.errorsViewmodel.multiFieldWarningsSelected(true);
				self.batchLayout.UserEditor.errorsViewmodel.regionErrorsSelected(true);
				self.batchLayout.UserEditor.errorsViewmodel.assemblyErrorsSelected(true);
				self.batchLayout.UserEditor.errorsViewmodel.errorsSelected(true);
				self.batchLayout.UserEditor.errorsViewmodel.warningsSelected(true);
				self.batchLayout.UserEditor.errorsViewmodel.fieldsToVerifySelected(true);

				var docModel = firstProblemDocument.Model;
				if (self.batchLayout.SelectedDocument() === docModel) {
					self.batchLayout.UserEditor.errorsViewmodel.selectedField(null); // Сбросим выделение, чтобы в любом случае восстановить фокус на форме данных
					self.batchLayout.UserEditor.errorsViewmodel.selectWorstError();
				} else {
					self.batchLayout.UserEditor.errorsViewmodel.autoSelectError = 2;
					window.batchApp.extensions.openDocument(docModel);
				}
			};

			self.Processing(false);

			FC_verify.showConfirmCloseDialog({
				environment: FC.Environment,
				sessionInfo: {
					ProjectID: FC.SessionInfo.ProjectID
				}
			},
				document.getElementById("reactDialogHost"),
				errorsCount,
				returnToFirstProblemDocument,
				self.FinishTaskAfterDocumentSaved
			);
		} else {
			self.FinishTaskAfterDocumentSaved();
		}
	};

	self.FinishTask = function () {
		if (self.batchLayout.UserEditor.documentHasChanges()) {
			self.batchLayout.UserEditor.checkRules(false, true, checkErrorsAndSave, false);
		} else {
			checkErrorsAndSave();
		}
	};

	self.FinishTaskAfterDocumentSaved = function () {
		eventManager.trigger('processingStarted', { text: FC.Environment.Localization.GlobalResources.ClosingDocument });

		FC.DataContext.Task.finish(
			getDocsArray(),
			self.taskId(),
			function () {
				eventManager.trigger('processingFinished');
			},
			function () {
				self.tryLeavePage("FC_Verification_TaskClosed");
			});

	};

	self.showErrorWindow = function () {
		UndoEngine.CleanStacks();

		window.removeEventListener(unloadEventName, unload);
		window.removeEventListener('beforeunload', beforeunload);

		self.batchLayout.centerFrameDisabled(false);
		self.batchLayout.rightFrameDisabled(false);

		self.TaskLoaded(false);

		self.canRescan(false);
		self.canClose(false);
		self.canPostpone(false);

		self.Processing(false);

		self.ErrorShower().show();
	};

	var getRedirectUrl = function (whereToGo, forceLeave) {
		if (FC.Environment.StationType === FC.StationType.WebCapture) {
			return FC.Utils.prepareRedirectUrl("Main/Index?projectId=" + self.projectId());
		}

		if (whereToGo && whereToGo.toLowerCase() === "batchlist") {
			return FC.Utils.prepareRedirectUrl("Batches?projectId=" + self.projectId() + "&roleId=" + FC.SessionInfo.RoleID);
		}

		if (!window.batchApp.extensions.autoGetModeSelectable || !window.batchApp.extensions.autoGetMode() || forceLeave) {
			return FC.Utils.prepareRedirectUrl("QueueList?projectId=" + self.projectId() + "&roleId=" + FC.SessionInfo.RoleID);
		}

		return FC.Utils.addParameterToUrl('autoget', true, FC.Utils.removeQueryParameter('autoget', FC.Utils.removeQueryParameter("taskId")));
	};

	self.tryLeavePage = function (message, forceLeave, wasError, errorMessage) {
		UndoEngine.CleanStacks();

		window.removeEventListener('beforeunload', beforeunload);

		self.batchLayout.centerFrameDisabled(false);
		self.batchLayout.rightFrameDisabled(false);

		self.canRescan(false);
		self.canClose(false);
		self.canPostpone(false);

		if (window.parent && window.parent !== window.self) {
			var event = new FC.Utils.EventData(message, null, errorMessage);

			window.parent.postMessage(event.ToJson(), "*"); //NOSONAR
			// "Make sure this cross-domain message is being sent to the intended domain."
			// у нас используется интеграция через iframe, и по-другому не сделать
		}

		var whereToGo = FC.Utils.getQueryParameter("returnTo");

		if (whereToGo && whereToGo.toLowerCase() === "deadend") {
			if (wasError) {
				self.ErrorShower().errorMessage(errorMessage);
				self.ErrorShower().show();
			} else {
				self.Deadender().show();
			}
			return;
		}

		var redirectUrl = getRedirectUrl(whereToGo, forceLeave);


		if (redirectUrl) {
			FC.Utils.replaceLocation(redirectUrl);
		} else {
			window.location.reload();
		}
	};

	self.taskIdSpecified = ko.observable(false);

	self.OnSendToStage = function () {
		eventManager.trigger('processingStarted');

		var send = function () {
			FC.DataContext.Task.moveToStage(
				getDocsArray(),
				self.taskId(),
				self.StageSelector().selectedUser(),
				self.StageSelector().selectedStage().Id,
				self.StageSelector().selectedPriority(),
				self.StageSelector().comment(),
				function () { self.tryLeavePage("FC_Verification_TaskSentToStage"); });
		};

		if (self.batchLayout.UserEditor.documentHasChanges() && self.StageSelector().selectedStage().Id !== 200) {
			self.batchLayout.UserEditor.checkRules(true, true, send, true);
		} else {
			send();
		}
	};

	self.OnSendToExceptions = function () {
		eventManager.trigger('processingStarted');

		var send = function () {
			FC.DataContext.Task.sendToExceptions(
				getDocsArray(),
				self.taskId(),
				self.SenderToExceptions().comment(),
				!self.sendToExceptionsNoEscape(),
				function () { self.tryLeavePage("FC_Verification_TaskSentToExceptions"); });
		};

		if (self.batchLayout.UserEditor.documentHasChanges()) {
			self.batchLayout.UserEditor.checkRules(true, true, send, true);
		} else {
			send();
		}
	};

	self.OnPostpone = function () {
		eventManager.trigger('processingStarted');
		var comment = self.PostponerWithSave().isVisible() ? self.PostponerWithSave().comment() : self.Postponer().comment();
		self.batchLayout.BatchEditor.deletedDocuments([]);
		self.documentsMoved(false);
		FC.DataContext.Task.postpone(
			getDocsArray(),
			self.taskId(),
			comment,
			false,
			function () {
				self.tryLeavePage("FC_Verification_TaskPostponed");
			});


	};

	self.OnSendToRescan = function () {
		eventManager.trigger('processingStarted');

		FC.DataContext.Task.rescan(
			getDocsArray(),
			self.taskId(),
			self.SenderToRescan().selectedUser(),
			self.SenderToRescan().comment(),
			function () { self.tryLeavePage("FC_Verification_TaskSentToRescan"); });
	};

	self.RejectTask = function () {
		eventManager.trigger('processingStarted');

		FC.DataContext.Task.reject(
			self.taskId(),
			function () { self.tryLeavePage("FC_Verification_TaskRejected", true); });
	};

	self.SaveAndRejectTask = function () {
		eventManager.trigger('processingStarted');

		var send = function () {
			FC.DataContext.Task.moveToStage(
				getDocsArray(),
				self.taskId(),
				0,
				self.stageId(),
				0,
				"",
				function () { self.tryLeavePage("FC_Verification_TaskSentToStage", true); });
		};

		if (!self.batchLayout.UserEditor.checkRules(true, false, send, true)) {
			send();
		}
	};

	self.PostponeAndSave = function () {
		eventManager.trigger('processingStarted');

		var postpone = function () {
			FC.DataContext.Task.postpone(
				getDocsArray(),
				self.taskId(),
				self.PostponerWithSave().comment(),
				true,
				function () {
					self.tryLeavePage("FC_Verification_TaskPostponed");
				});
		};

		if (self.batchLayout.UserEditor.documentHasChanges()) {
			self.batchLayout.UserEditor.checkRules(true, true, postpone, true);
		} else {
			postpone();
		}
	};

	self.StageSelector = ko.observable(new FC.Pages.StageSelector(false, self.OnSendToStage));
	self.SenderToExceptions = ko.observable(new FC.Pages.SenderToExceptions(false, self.OnSendToExceptions));
	self.sendToExceptionsNoEscape = ko.observable(false);
	self.SenderToRescan = ko.observable(new FC.Pages.StageSelector(false, self.OnSendToRescan));
	self.Postponer = ko.observable(new FC.Pages.ModalDialogWithComment(self.OnPostpone, "postponeDialogue"));
	self.SenderToRecognition = ko.observable(new FC.Pages.ModalDialogWithComment(self.OnRecognize, "sendToRecognitionDialogue"));
	self.Deadender = ko.observable(
		new FC.DialogBase(
			null,
			null,
			FC.Environment.AppPathNoTennant + 'WebCommonNew/Styles/Images/icon_128_allDone.png',
			true,
			FC.Environment.Headless, false, false, false, "deadEndDialogue"));

	self.ErrorShower = ko.observable(new FC.Pages.ErrorWindow(null));

	self.RejectDialog = ko.observable(new FC.Pages.RejectSaveDialog(
		self.RejectTask, null, window.batchApp.extensions.autoGetModeSelectable ? window.batchApp.extensions.autoGetMode : null, "rejectDialogue"));

	self.RejectSaveDialog = ko.observable(new FC.Pages.RejectSaveDialog(
		self.SaveAndRejectTask, self.RejectTask, window.batchApp.extensions.autoGetModeSelectable ? window.batchApp.extensions.autoGetMode : null, "rejectAndSaveDialogue"));


	self.PostponerWithSave = ko.observable(new FC.Pages.PostponeSaveDialog(self.PostponeAndSave, self.OnPostpone));

	self.canClose = ko.observable(false);
	self.canPostpone = ko.observable(false);
	self.canRescan = ko.observable(false);
	self.canSend = ko.observable(false);
	self.canSendToExceptions = ko.observable(false);
	self.canReject = ko.observable(false);

	self.SendToExceptions = function () {
		self.SenderToExceptions().show();
	};

	self.ShowStagesDialog = function () {
		self.StageSelector().updateStages(self.BatchId());
		self.StageSelector().show();
	};

	self.ShowRescan = function () {
		self.SenderToRescan().updateUsers(self.BatchId(), 150);
		self.SenderToRescan().show();
	};

	self.ShowRecognize = function () {
		self.SenderToRecognition().show();
	};

	self.ShowPostpone = function (hasChanges) {
		var dialog = hasChanges ? self.PostponerWithSave : self.Postponer;
		dialog().show();
	};

	self.ShowReject = function (hasChanges) {
		var dialog = hasChanges ? self.RejectSaveDialog : self.RejectDialog;
		dialog().show();
	};

	self.closeSession = function (onSuccess) {
		dependencies.serverDataContext.closeSession(onSuccess);
	};

	self.canSeeBatchList = ko.observable((0x00000100 & FC.SessionInfo.Permissions) > 0);

	self.OnPageOpening = function (onSuccess) {
		self.batchLayout.centerFrameDisabled(false);
		self.batchLayout.rightFrameDisabled(false);
		if (taskDocuments) {
			self.batchLayout.showTwoPanelsLocker(null,
				FC.Environment.Localization.GlobalResources.DocLoadMessage,
				'');

			self.onTaskDocumentsLoad(taskDocuments);
		}

		var footer = document.getElementById('MainFooter');
		if (footer) {

			var target = footer.getElementsByClassName('footer_container');
			if (target.length > 0) {

				var footerItem = document.createElement('div');
				footerItem.setAttribute('class', 'footer_item');

				var keyboardButton = document.createElementNS('http://www.w3.org/2000/svg', 'svg');
				keyboardButton.setAttribute('class', 'shortcuts-keyboard');

				var keyboardButtonUse = document.createElementNS('http://www.w3.org/2000/svg', 'use');
				keyboardButtonUse.setAttributeNS('http://www.w3.org/1999/xlink', 'xlink:href', '#icon-keyboard-shortcuts');

				keyboardButton.appendChild(keyboardButtonUse);
				footerItem.appendChild(keyboardButton);

				keyboardButton.addEventListener('click',
					function (e) { FC_verify.showKeyboardShortcuts(e, { environment: FC.Environment }, document.getElementById("reactShortcutsHost")); }
				);

				target[0].appendChild(footerItem);
			}
		}

		if (onSuccess) {
			onSuccess();
		}
	};

	self.OnPageUnload = function (needConfirm) {
		window.removeEventListener(unloadEventName, unload);
		window.removeEventListener('beforeunload', beforeunload);


		if (!self.TaskLoaded()) {
			return true; // разрешаем переход
		}

		if (needConfirm && !FC.Utils.Confirm(FC.Environment.Localization.GlobalResources.UnloadPrompt)) {
			return false;
		}

		if (needConfirm) { // значит страница не перегружается, навигация по сэмми			
			//self.batchLayout.DocumentEditor().Dispose(true, true);
			//self.batchLayout.DocumentEditor(new FC.Viewmodels.DocumentEditor.GeneralViewmodel());
			self.TaskLoaded(false);
		}

		UndoEngine.CleanStacks();

		self.closeSession();

		return true;
	};

	var onMessageCame = function (message) {
		if (!message || !message.data || !message.data.hasOwnProperty("eventName")) {
			return;
		}

		if (message.data.eventName === "FC_Verification_Close") {
			var onSessionClosed = function () {
				window.removeEventListener(unloadEventName, unload);
				window.removeEventListener('beforeunload', beforeunload);

				self.TaskLoaded(false);

				if (window.parent && window.parent !== window.self) {
					window.parent.postMessage(new FC.Utils.EventData("FC_Verification_Closed").ToJson(), "*");//NOSONAR
					// "Make sure this cross-domain message is being sent to the intended domain."
					// у нас используется интеграция через iframe, и по-другому не сделать
				}
			};

			if (!self.TaskLoaded()) {
				onSessionClosed();
				return;
			}

			self.closeSession(onSessionClosed);
		}
	};

	if (window.parent && window.parent !== window.self) {
		window.addEventListener("message", onMessageCame, false);
	}
};

FC.Pages.VerifyPage.showDocumentUnsavedConfirm = function (documentName, onSave, onNotSave) {
	var showConfirm = JSON.parse(localStorage.getItem('showDocumentUnsavedConfirm'));

	if (showConfirm === false) {
		onSave();
		return;
	}

	// состояние переменной соответствует состоянию чекбокса
	FC.showDocumentUnsavedConfirm = true;
	var checkboxMarkup = '<label class="checkbox-label--big">' +
		'<input type="checkbox" class="confirmWindowCheckbox" ' +
		'onchange="FC.showDocumentUnsavedConfirm = !$(this).is(\':checked\');"/>' +
		'<span class="checkbox-helper--big"></span>' +
		'<span class="checkbox-text">' + FC.Environment.Localization.GlobalResources.SaveOpenedDocumentEvetytime_Text + '</span>' +
		'</label>';

	var buttons = [
		// кнопка "Сохранить"
		new FC.Utils.Notification.Button(
			FC.Environment.Localization.GlobalResources.ConfirmApplyChanges_ButtonText,
			function () {
				if (FC.showDocumentUnsavedConfirm !== undefined &&
					FC.showDocumentUnsavedConfirm === false) {
					localStorage.setItem('showDocumentUnsavedConfirm', false);
				}
				onSave();
			},
			FC.Utils.Notification.ButtonType.primary),


		// кнопка "Прожолжить без изменений"
		new FC.Utils.Notification.Button(
			FC.Environment.Localization.GlobalResources.ConfirmOpenWithoutChanges_ButtonText,
			onNotSave),

		// кнопка "Отмены"
		new FC.Utils.Notification.Button(
			FC.Environment.Localization.GlobalResources.ConfirmCancel_ButtonText,
			null)
	];

	FC.Utils.Notification.ConfirmWindowAdvanced(
		FC.Environment.Localization.GlobalResources.SaveOpenedDocumentTitle,
		checkboxMarkup,
		buttons);

};

FC.Pages.VerifyPage.showNeedRecognizeLocker = function () {
	FC.Pages.VerifyPage.showRerecognizeLocker(FC.Pages.VerifyPage.formLockerModes.needRecognize);
};

FC.Pages.VerifyPage.showRerecognizeLocker = function (mode, title, text) {
	var doc = window.batchLayout.batchLayoutViewModel.SelectedDocument();
	var noCancel =  doc && !doc.definitionIsRevertable();

	var docsToRecognizeCount = window.batchLayout.batchLayoutViewModel.BatchEditor.elements().filter(function (doc) {
		return doc.Model.Status() === FC.BatchEditor.Document.Status.NeedRecognize;
	}).length;

	var lockerData = {
		lockerMode: mode,
		docsToRecognizeCount: docsToRecognizeCount,
		noCancel: noCancel,
		title: title,
		text: text,
		canGotoNextDocument: window.batchLayout.batchLayoutViewModel.BatchEditor.elements().length > 1
	};
	window.batchLayoutComponent.store.dispatch({ type: 'BATCH_LAYOUT_SHOW_LOCKER', lockerIndex: 1, lockerData: lockerData });
};

FC.Pages.VerifyPage.hideRerecognizeLocker = function () {
	window.batchLayoutComponent.store.dispatch({ type: 'BATCH_LAYOUT_HIDE_LOCKER', lockerIndex: 1 });
};

FC.Pages.VerifyPage.formLockerModes = {
	needRecognize: 1,
	isRecognizing: 2,
	needApplyChanges: 3,
	isCheckingRules: 4
};