﻿FC.Utils.runAjax = function (options) {
	if (!options || !options.hasOwnProperty("url")) {
		return;
	}

	$.ajax({
		url: options.url,
		type: options.hasOwnProperty("type") ? options.type : "GET",
		data: options.hasOwnProperty("data") ? options.data : {},
		xhrFields: {
			withCredentials: true
		},
		dataType: "json",
		beforeSend: FC.Utils.beforeAjaxSend,
		success: function (result) {
			if (result.Error) {
				FC.Utils.HandleServerError(result.Error);
				if (options.hasOwnProperty("onFail") && options.onFail) {
					options.onFail(result.Error);
				}

				return;
			}

			if (result.RedirectUrl && !options.noRedirect) {
				FC.Utils.replaceLocation(FC.Utils.prepareRedirectUrl(result.RedirectUrl));
				return;
			}

			if (options.hasOwnProperty("onSuccess") && options.onSuccess) {
				options.onSuccess(result.Result);
			}
		},
		error: function (jqXhr, textStatus, errorThrown) {
			FC.Utils.HandleJqueryError(jqXhr, textStatus, errorThrown);
			if (options.hasOwnProperty("onFail") && options.onFail) {
				options.onFail(jqXhr);
			}
		}
	});
};

FC.Utils.beforeAjaxSend = function(xhr, settings) {
	xhr.url = settings.url;
};