﻿FC.Utils = FC.Utils || {};

FC.Utils.HandleServerError = function handleServerError(error) {
	if (error == null) {
		return;
	}

	if (error.Code === 403 || error.Code === 401) {
		FC.Utils.RedirectOnUnauthorized();
		return;
	}
	
	if (error.Message && error.Message.length > 0) {
		FC.Utils.Error.Show(error.Message);
	}
};

FC.Utils.HandleJqueryError = function handleJqueryError(jqXhr, textStatus, errorThrown) {
	if (jqXhr != null) {
		if (jqXhr.status === 403 || jqXhr.status === 401) {
			FC.Utils.RedirectOnUnauthorized();
			return;
		}

		if (jqXhr.status === 200) {
			// с сервера вернулся html
			document.documentElement.innerHTML = jqXhr.responseText;
			return;
		}
	}
	if (errorThrown && errorThrown.length > 0) {
		FC.Utils.Error.Show(errorThrown);
	}
};

FC.Utils.RedirectOnUnauthorized = function redirectOnUnauthorized() {
	var queryString = FC.Environment.LoginRedirectUrl;

	var loc = FC.Utils.getLocation();
	if (loc.href.toLowerCase().indexOf('winAuth') > -1) {
		if (queryString.indexOf('?') > -1) {
			queryString += '&windowsAuth=true';
		} else {
			queryString += '?windowsAuth=true';
		}
	}

	if (queryString.indexOf('?') > -1) {
		queryString += '&returnTo=';
	} else {
		queryString += '?returnTo=';
	}

	queryString += encodeURIComponent(FC.Utils.getLocation().href);

	var mode = FC.Utils.getQueryParameter("mode");
	if (mode && queryString.indexOf('mode=')<0) {
		queryString += "&mode=" + mode;
	}

	if (window.parent && window.parent !== window.self) {
		window.parent.postMessage({ action: "accessTokenExpired" }, "*");//NOSONAR
		// "Make sure this cross-domain message is being sent to the intended domain."
		// у нас используется интеграция через iframe, и по-другому не сделать
	}

	FC.Utils.replaceLocation(queryString);
};

FC.Utils.HandleProcessingError = function (jqXhr, textStatus, errorThrown) {
	Sammy.apps.body.trigger('processingFinished');

	if (jqXhr != null && jqXhr.status === 0) {
		FC.Utils.Error.Show(FC.Environment.Localization.GlobalResources.ServerUnavailible);
		return;
	}

	FC.Utils.HandleJqueryError(jqXhr, textStatus, errorThrown);
};

