﻿Sammy.Application.prototype.unbindEvent = function (eventName) {
	this.unbindByCondition(function (name) {
		return name === eventName;
	});	
};

Sammy.Application.prototype.unbindByPrefix = function (eventPrefix) {
	this.unbindByCondition(function (name) {
		return name.indexOf(eventPrefix) === 0;
	});	
};


Sammy.Application.prototype.unbindByCondition = function (checkName) {
	if (!checkName || typeof checkName !== "function") {
		return;
	}

	var app = this;

	var eventNames = Object.getOwnPropertyNames(app.listeners);
	for (var i = 0; i < eventNames.length; i++) {
		var name = eventNames[i];
		var listeners = app.listeners[name];

		if (checkName(name)) {
			$.each(listeners, function (it, listenerCallback) {
				app._unlisten(name, listenerCallback);
			});

			delete app.listeners[name];
		}
	}
};