﻿FC.Utils = FC.Utils || {};

FC.Utils.getFullUrlNoTennant = function (url) {
	var baseUrl = FC.Environment.AppPathNoTennant;
	if (!url) {
		return baseUrl;
	}

	var separator = '/';

	// По-хорошему, здесь нужно было сделать что-то типа 
	// return new URL(url, FC.Environment.AppPathNoTennant).href;
	// К сожалению, IE 11 не умеет в new URL(), а добавлять полифиллы очень страшно (непонятно что где из-за этого отвалится)
	// Поэтому костылим руками

	if (baseUrl.indexOf(separator, baseUrl.length - separator.length) === -1) { // !baseUrl.endsWith(separator)
		baseUrl += separator;
	}

	if (url.indexOf(separator) === 0) { // url.startsWith(separator)
		url = url.slice(1);
	}

	return baseUrl + url;
}

FC.Utils.getControllerUrl = function (shortPath) {
	var urlPrefix = '';
	var loc = FC.Utils.getLocation();

	if (loc.search.toLowerCase().indexOf('winauth') > -1 ||
		loc.hash.toLowerCase().indexOf('winauth') > -1) {
		urlPrefix = 'WinAuth/';
	}

	return FC.Environment.AppPath + urlPrefix + shortPath;
};

FC.Utils.prepareRedirectUrl = function (url) {
	var newUrl = url.indexOf(FC.Environment.AppPath) === 0 ? url : FC.Environment.AppPath + url;
	var mode = FC.Utils.getQueryParameter("mode");
	var showAutoReceiveTasksOption = FC.Utils.getQueryParameter("showAutoReceiveTasksOption");

	if (mode) {
		newUrl += newUrl.indexOf("?") > -1 ? "&" : "?";
		newUrl += "mode=" + mode;
	}

	if (showAutoReceiveTasksOption) {
		newUrl += newUrl.indexOf("?") > -1 ? "&" : "?";
		newUrl += "showAutoReceiveTasksOption=" + showAutoReceiveTasksOption;
	}

	return newUrl;
};

FC.Utils.pageUrls = {
	main: function () {
		return FC.Utils.prepareRedirectUrl("Main?projectId=" + FC.SessionInfo.ProjectID);
	},
	queues: function() {
		return FC.Utils.prepareRedirectUrl("QueueList?projectId=" + FC.SessionInfo.ProjectID + "&roleId=" + FC.SessionInfo.RoleID);
	},
	batches: function () {
		return FC.Utils.prepareRedirectUrl("Batches?projectId=" + FC.SessionInfo.ProjectID + "&roleId=" + FC.SessionInfo.RoleID);
	},
	postponedTasks: function() {
		return FC.Utils.prepareRedirectUrl("Tasks?projectId=" +
			FC.SessionInfo.ProjectID +
			"&roleId=" +
			FC.SessionInfo.RoleID +
			"&postponed=true");
	}
};

FC.Utils.getQueryParameter = function (key) {
	var query = FC.Utils.getFullQueryString();

	if (query.length < 2) {
		return null;
	}

	var parameters = query.substring(1).split("&");
	for (var i = 0; i < parameters.length; i++) {
		var keyValue = parameters[i].split("=");
		if (keyValue[0].toLowerCase() === key.toLowerCase()) {
			return keyValue[1];
		}
	}

	return null;
};

FC.Utils.getQueryParameterArray = function (key) {
	var query = FC.Utils.getFullQueryString();

	if (query.length < 2) {
		return null;
	}

	var result = [];
	var parameters = query.substring(1).split("&");
	for (var i = 0; i < parameters.length; i++) {
		var keyValue = parameters[i].split("=");
		if (keyValue[0].toLowerCase() === key.toLowerCase()) {
			result.push(keyValue[1]);
		}
	}

	return result;
};

FC.Utils.getFullQueryString = function () {
	var loc = FC.Utils.getLocation();

	// кусок query может быть в hash
	var questionIndexInHash = loc.hash.indexOf('?');

	if (questionIndexInHash === -1) {
		return loc.search;
	}

	var questionIndexInSearch = loc.search.indexOf('?');
	if (questionIndexInSearch === -1) {
		return loc.hash.substring(questionIndexInHash);
	}

	return loc.search + "&" + loc.hash.substring(questionIndexInHash + 1);
};

FC.Utils.removeQueryParameter = function(parameterName, url) {
	var loc = url || window.location.toString();
	var queryIndex = loc.indexOf("?");
	if (queryIndex < 0) {
		return loc;
	}

	var newUrl = loc.substring(0, queryIndex);
	var query = loc.substr(queryIndex);

	if (query.length < 2) {
		return loc;
	}

	newUrl += "?";
	var parameters = query.substring(1).split("&");
	var firstParam = true;
	for (var i = 0; i < parameters.length; i++) {
		var keyValue = parameters[i].split("=");
		if (keyValue[0].toLowerCase() !== parameterName.toLowerCase()) {
			if (!firstParam) {
				newUrl += "&";
			}
			newUrl += parameters[i];
			firstParam = false;
		}
	}

	return newUrl;
};


FC.Utils.addParameterToUrl = function(paramName, paramValue, url) {
	var newParam = paramName + '=' + paramValue;
	return url + (url.indexOf('?') < 0?'?':'&') + newParam;
}