﻿window.selectionTools = {};

/**
*	Возращает границы текущего выделения текста внутри element'a
*/
window.selectionTools.getSelectionBoundaries = function getSelectionBoundaries(element) {

	if (!element.hasChildNodes()
		|| (element.childNodes.length == 1 && $(element.childNodes[0]).is("br"))) {
		return {
			start: 0,
			end: 0,
			collapsed: 1,
			length: 0
		};
	}

	var offsetStart = 0;
	var offsetStartFound = false;
	var offsetEnd = 0;
	var offsetEndFound = false;
	var selection = null;
	if (typeof window.getSelection != "undefined") {
		selection = window.getSelection();
	}

	if (selection != null && selection.rangeCount) {

		// если выделение не находится внтури переданного элемента element
		if (!$(selection.anchorNode).closest(element).length &&
			!$(selection.focusNode).closest(element).length) {
			return null;
		}

		var range = window.getSelection().getRangeAt(0);

		// поиск правой границы выделения 
		if (range.endContainer.nodeType == 1 && range.endContainer.hasChildNodes) {

			var endNode = range.endContainer.childNodes[range.endOffset];
			if ($(endNode).is("br")) {
				offsetEnd = parseInt(endNode.dataset.index);
				offsetEndFound = true;
			}
		}

		var preCaretRange;
		var brCount;
		var nodes;
		var childCount;
		if (!offsetEndFound) {
			preCaretRange = range.cloneRange();
			preCaretRange.selectNodeContents(element);
			preCaretRange.setEnd(range.endContainer, range.endOffset);
			nodes = preCaretRange.cloneContents();
			brCount = $("br", $(nodes)).length || 0;

			offsetEnd = preCaretRange.toString().length + brCount;

			if (range.endContainer == element && brCount > 1) {
				childCount = element.childNodes.length;
				if ($(element.childNodes[childCount - 1]).is("br")
					&& $(element.childNodes[childCount - 2]).is("br")) {
					offsetEnd--;
				}
			}
		}


		// поиск левой границы выделения
		if (range.startContainer.nodeType == 1 && range.startContainer.hasChildNodes) {

			var startNode = range.startContainer.childNodes[range.startOffset];
			if ($(startNode).is("br")) {
				offsetStart = parseInt(startNode.dataset.index);
				offsetStartFound = true;
			}
		}

		if (!offsetStartFound) {
			preCaretRange = range.cloneRange();
			preCaretRange.selectNodeContents(element);
			preCaretRange.setEnd(range.startContainer, range.startOffset);

			nodes = preCaretRange.cloneContents();
			brCount = $("br", $(nodes)).length || 0;

			offsetStart = preCaretRange.toString().length + brCount;

			// если самые последние 2 символа в разметке - это br, 
			// то нужно сместить позицию сдвига на один элемент назад
			if (range.startContainer == element && brCount > 1) {
				childCount = element.childNodes.length;
				if ($(element.childNodes[childCount - 1]).is("br")
					&& $(element.childNodes[childCount - 2]).is("br")) {
					offsetStart--;
				}

			}
		}
	}

	return {
		start: offsetStart,
		end: offsetEnd,
		collapsed: offsetStart == offsetEnd,
		length: Math.abs(offsetEnd - offsetStart)
	};
};