﻿FC.Viewmodels.ActionZones.BorderBottomRightZone = function borderBottomRightZone(rectangles, target, page, depth) {
	if (!rectangles) {
		throw "no rectangle";
	}

	var zoneRect = ko.pureComputed(function () {
		var newRects = [];
		var rects = ko.utils.unwrapObservable(rectangles);

		for (var i = 0; i < rects.length; i++) {
			newRects.push(new FC.Viewmodels.ImageEditor.Rectangle(
			{
				x1: rects[i].x2() - FC.Viewmodels.ActionZones.zoneConstants.borderZonesPadInside / page.zoom(),
				y1: rects[i].y2() - FC.Viewmodels.ActionZones.zoneConstants.borderZonesPadInside / page.zoom(),
				x2: rects[i].x2() - (FC.Viewmodels.ActionZones.zoneConstants.borderZonesPadInside - FC.Viewmodels.ActionZones.zoneConstants.borderZoneSize) / page.zoom(),
				y2: rects[i].y2() - (FC.Viewmodels.ActionZones.zoneConstants.borderZonesPadInside - FC.Viewmodels.ActionZones.zoneConstants.borderZoneSize) / page.zoom()
			}));
		}

		return newRects;
	});

	FC.Viewmodels.ActionZones.BorderZoneBase.call(this, zoneRect, target, rectangles, page, depth);

	this.cursorStyle(FC.Viewmodels.ActionZones.cursorTypes.southEastResize);
};

FC.Viewmodels.ActionZones.BorderBottomRightZone.prototype = Object.create(FC.Viewmodels.ActionZones.BorderZoneBase.prototype);

FC.Viewmodels.ActionZones.BorderBottomRightZone.prototype.mouseMove = function (zone, point) {
	var deltaX = point.x - zone.startPoint.x;
	var deltaY = point.y - zone.startPoint.y;

	zone.mouseMoveBase(zone, point, { x1: 0, y1: 0, x2: deltaX, y2: deltaY });
};	