﻿FC.Viewmodels.ActionZones.CellBodyZone = function cellBodyZone(rectangles, target, page, depth, parentRegion) {
	FC.Viewmodels.ActionZones.RegionBodyZone.call(this, rectangles, target, page, depth);

	this.parentRegion = parentRegion;
	this.cursorStyle = ko.pureComputed(function () {
		if (target.selected())
			return FC.Viewmodels.ActionZones.cursorTypes.crosshair;

		return FC.Viewmodels.ActionZones.cursorTypes.pointer;
	});

	this.depth = ko.computed(function () {
		var docEditor = window.batchLayout.batchLayoutViewModel.DocumentEditor();
		if (docEditor.extender.horizontalSeparatorDrawActivated() ||
			docEditor.extender.verticalSeparatorDrawActivated()) {
			return -1;
		} else {
			return depth;
		}
	});

	this.page.subscriptions.push({
		key: this.target,
		value: this.depth
	});
	this.page.subscriptions.push({
		key: this.target,
		value: this.target.selected.subscribe(
			function(isSelected) {
				if (isSelected) {
					page.selectRegion(target.parentRegion, false);
				}
			})
	});
};

FC.Viewmodels.ActionZones.CellBodyZone.prototype = Object.create(FC.Viewmodels.ActionZones.RegionBodyZone.prototype);

FC.Viewmodels.ActionZones.CellBodyZone.prototype.mouseDown = function (point) {
	if (!this.pointIsInside(point)) {
		return false;
	}

	if (!this.target.selected()) {
		this.selectTarget();
	} else {
		var parentBodyZone = this.page.findRegionZoneForPoint(this.parentRegion, point);
		if (parentBodyZone) {
			parentBodyZone.mouseDown(point);
		}
	}

	return true;
};

FC.Viewmodels.ActionZones.CellBodyZone.prototype.mouseUp = function () { };

FC.Viewmodels.ActionZones.CellBodyZone.prototype.mouseMove = function () { };