﻿FC.Viewmodels.ActionZones.DeleteZone = function deleteZone(rectangles, target, page, depth) {
	var zoneRect = ko.pureComputed(function () {
		var rects = ko.utils.unwrapObservable(rectangles);
		var top = 100000;
		var right = 0;

		for (var i = 0; i < rects.length; i++) {
			if (right <= rects[i].x2()) {
				right = rects[i].x2();
			}

			if (top >= rects[i].y1()) {
				top = rects[i].y1();
			}
		}

		return [new FC.Viewmodels.ImageEditor.Rectangle(
			{
				x1: right,
				y1: top - 20 / page.zoom(),
				x2: right + 20 / page.zoom(),
				y2: top
			})];
	});
	
	FC.Viewmodels.ActionZones.BaseZone.call(this, zoneRect, target, page, FC.Viewmodels.ActionZones.zoneActivationType.selected);

	this.depth(depth + 110);
	this.cursorStyle(FC.Viewmodels.ActionZones.cursorTypes.pointer);
};

FC.Viewmodels.ActionZones.DeleteZone.prototype = Object.create(FC.Viewmodels.ActionZones.BaseZone.prototype);

FC.Viewmodels.ActionZones.DeleteZone.prototype.draw = function (activeLayerIndex) {
	if (!this.isActive() || activeLayerIndex === 0) {
		return;
	}

	var rect = this.rectangles()[0];
	var right = Math.round(rect.x1());
	var top = Math.round(rect.y2());

	var layer = this.page.getLayer(1);

	var circleSize = 10 / this.page.zoom();
	var textPadding = 4 / this.page.zoom();
	layer.drawCircleWithShadow(new FC.Viewmodels.ImageEditor.Point(right + circleSize, top - circleSize), circleSize, "#ffffff", "rgba(53, 124, 183, 0.6)", 0, 2, 3);
	
	layer.drawText(new FC.Viewmodels.ImageEditor.Point(right + textPadding, top - textPadding), "\ue923", "#c60c30", 12, "abbyy-icons");
};

FC.Viewmodels.ActionZones.DeleteZone.prototype.mouseDown = function (point) {
	if (!this.isActive() || !this.pointIsInside(point)) {
		return false;
	}

	this.page.deleteRegion(this.target);
	return true;
};	

