﻿FC.Viewmodels.ActionZones.GroupBodyEditableZone = function groupBodyEditableZone(rectangles, target, page, depth) {
	var zoneRects = ko.pureComputed(function () {
		var newRects = [];
		var rects = ko.utils.unwrapObservable(rectangles);

		for (var i = 0; i < rects.length; i++) {
			newRects.push(new FC.Viewmodels.ImageEditor.Rectangle({
				x1: rects[i].x1() + FC.Viewmodels.ActionZones.zoneConstants.groupMovableZoneWidth / page.zoom(),
				y1: rects[i].y1() + FC.Viewmodels.ActionZones.zoneConstants.groupMovableZoneWidth / page.zoom(),
				x2: rects[i].x2() - FC.Viewmodels.ActionZones.zoneConstants.groupMovableZoneWidth / page.zoom(),
				y2: rects[i].y2() - FC.Viewmodels.ActionZones.zoneConstants.groupMovableZoneWidth / page.zoom()
			}));
		}

		return newRects;
	});

	FC.Viewmodels.ActionZones.RegionBodyZone.call(this, zoneRects, target, page, depth);

	if (!this.target.field() || !(this.target.field() instanceof FC.BusinessModels.DocumentEditor.ChoiceField)) {
		this.depth(depth);
	}

	this.sourceRectangles = rectangles;
	this.selectParentOnSelect = false;
	this.cursorStyle(FC.Viewmodels.ActionZones.cursorTypes.crosshair);
	this.modifiedCursorStyle = FC.Viewmodels.ActionZones.cursorTypes.modifyRegion;
	this.regionCreator = null;
};

FC.Viewmodels.ActionZones.GroupBodyEditableZone.prototype = Object.create(FC.Viewmodels.ActionZones.RegionBodyZone.prototype);

FC.Viewmodels.ActionZones.GroupBodyEditableZone.prototype.draw = function () { };

FC.Viewmodels.ActionZones.GroupBodyEditableZone.prototype.mouseDown = function (point) {
	if (!this.pointIsInside(point)) {
		return false;
	}

	var self = this;

	var onMouseMove = function (rectangle, currentZone, p) {
		FC.Viewmodels.ActionZones.RecognizedTextZone.selectZonesInsideRectangle(rectangle, p);
	};

	var onMouseUp = function (rectangle, parentRegion, page, event) {
		if (FC.Viewmodels.DocumentEditor.RegionCreator.regionTooSmallToCreate(rectangle)) {
			self.selectTarget();
			return;
		}

		var text = FC.Viewmodels.DocumentEditor.TextRegionViewModel.getTextInsideRectangle(rectangle, page);
		page.createRegion(rectangle, self.target, event, text);
	};

	self.regionCreator = self.regionCreator || new FC.Viewmodels.DocumentEditor.RegionCreator(self.page, onMouseMove, onMouseUp);
	self.regionCreator.startRegionDrawing(point, self);
	return true;
};