﻿FC.Viewmodels.ActionZones.GroupBodyMovableZone = function groupBodyMovableZone(rectangles, target, page, depth) {
	var zoneRects = ko.pureComputed(function () {
		var newRects = [];
		var rects = ko.utils.unwrapObservable(rectangles);

		for (var i = 0; i < rects.length; i++) {
			newRects.push(new FC.Viewmodels.ImageEditor.Rectangle({
				x1: rects[i].x1(),
				y1: rects[i].y1(),
				x2: rects[i].x2(),
				y2: rects[i].y1() + FC.Viewmodels.ActionZones.zoneConstants.groupMovableZoneWidth / page.zoom()
			}));

			newRects.push(new FC.Viewmodels.ImageEditor.Rectangle({
				x1: rects[i].x1(),
				y1: rects[i].y1() + FC.Viewmodels.ActionZones.zoneConstants.groupMovableZoneWidth / page.zoom(),
				x2: rects[i].x1() + FC.Viewmodels.ActionZones.zoneConstants.groupMovableZoneWidth / page.zoom(),
				y2: rects[i].y2() - FC.Viewmodels.ActionZones.zoneConstants.groupMovableZoneWidth / page.zoom()
			}));

			newRects.push(new FC.Viewmodels.ImageEditor.Rectangle({
				x1: rects[i].x2() - FC.Viewmodels.ActionZones.zoneConstants.groupMovableZoneWidth / page.zoom(),
				y1: rects[i].y1() + FC.Viewmodels.ActionZones.zoneConstants.groupMovableZoneWidth / page.zoom(),
				x2: rects[i].x2(),
				y2: rects[i].y2() - FC.Viewmodels.ActionZones.zoneConstants.groupMovableZoneWidth / page.zoom()
			}));

			newRects.push(new FC.Viewmodels.ImageEditor.Rectangle({
				x1: rects[i].x1(),
				y1: rects[i].y2() - FC.Viewmodels.ActionZones.zoneConstants.groupMovableZoneWidth / page.zoom(),
				x2: rects[i].x2(),
				y2: rects[i].y2()
			}));
		}

		return newRects;
	});

	FC.Viewmodels.ActionZones.RegionBodyZone.call(this, zoneRects, target, page, depth);

	if (!this.target.field() || !(this.target.field() instanceof FC.BusinessModels.DocumentEditor.ChoiceField)) {
		this.depth(depth);
	}
	this.sourceRectangles = rectangles;
	this.selectParentOnSelect = false;
	this.cursorStyle(FC.Viewmodels.ActionZones.cursorTypes.move);
};

FC.Viewmodels.ActionZones.GroupBodyMovableZone.prototype = Object.create(FC.Viewmodels.ActionZones.RegionBodyZone.prototype);

FC.Viewmodels.ActionZones.GroupBodyMovableZone.prototype.draw = function (layerIndex) {
	if (layerIndex === 0 && this.target.selected() || layerIndex === 1 && !this.target.selected() || !this.target.field()) {
		return;
	}

	var layer = this.page.getLayer(this.target.selected() ? 1 : 0);

	var selected = this.target.selected || this.target.highlighted();
	var cssClass = selected ? ".regionParent-selected" : ".regionParent-default";

	var isCheckboxGroup = this.target.field().fieldType === FC.BusinessModels.DocumentEditor.FieldTypes.Choice;
	var isGroup = this.target.field().fieldType === FC.BusinessModels.DocumentEditor.FieldTypes.GroupParent;

	if (isCheckboxGroup) {
		cssClass = selected ? ".regionChoice-selected" : ".regionChoice-default";
	} else if (isGroup) {
		cssClass = selected ? ".regionGroup-selected" : ".regionGroup-default";
	}

	var borderWidth = FC.Utils.GetCssClassValue(cssClass, "border-width");
	if (!borderWidth) {
		borderWidth = 0;
	} else {
		borderWidth = parseInt(borderWidth.replace('px', ''));
	}

	var borderColor = FC.Utils.GetCssClassValue(cssClass, "border-color");

	layer.drawPolygon(this.sourceRectangles(), borderWidth, borderColor);
};