﻿FC.Viewmodels.ActionZones.TableGroupZone = function tableGroupZone(rectangles, target, page, depth) {
	FC.Viewmodels.ActionZones.TableBodyEditableZone.call(this, rectangles, target, page, 0);

	var self = this;
	var onRegionDrawing = function (p) {
		self.regionCreator.regionDrawing(p, self);

		var rectangle = FC.Viewmodels.ImageEditor.Rectangle.getRectangleFromPoints(p, self.regionCreator.startPoint);
		FC.Viewmodels.ActionZones.RecognizedTextZone.selectZonesInsideRectangle(rectangle, self.page);
	};

	var onRegionCreating = function (p, e) {
		self.page.deselectHovering = true;

		var rectangle = FC.Viewmodels.ImageEditor.Rectangle.getRectangleFromPoints(p, self.regionCreator.startPoint);

		if (FC.Viewmodels.DocumentEditor.RegionCreator.regionTooSmallToCreate(rectangle)) {
			return;
		}

		var regions = self.page.selectedRegions();
		var text = FC.Viewmodels.DocumentEditor.TextRegionViewModel.getTextFromRegions(regions);
		self.page.createRegion(rectangle, self.target, e, text);
	};

	var onSeparatorCreated = function () {
		self.page.deselectHovering = true;
	};

	this.regionCreator = new FC.Viewmodels.DocumentEditor.RegionCreator(this.page, null, null);
	this.separatorCreator = new FC.Viewmodels.DocumentEditor.TableSeparatorCreator(this.page, this.target, onRegionDrawing, onRegionCreating, onSeparatorCreated, 7);
};

FC.Viewmodels.ActionZones.TableGroupZone.prototype = Object.create(FC.Viewmodels.ActionZones.TableBodyEditableZone.prototype);

FC.Viewmodels.ActionZones.TableGroupZone.prototype.mouseDown = function (point) {
	if (!this.pointIsInside(point)) {
		return false;
	}

	this.selectTarget();

	var docEditor = window.batchLayout.batchLayoutViewModel.DocumentEditor();
	if (!docEditor.extender.horizontalSeparatorDrawActivated() && !docEditor.extender.verticalSeparatorDrawActivated()) {
		this.regionCreator.startPoint = point;
		this.separatorCreator.startSeparatorDrawing(point);
		this.page.deselectHovering = false;
		return true;
	}

	if (docEditor.extender.horizontalSeparatorDrawActivated()) {
		this.separatorCreator.addHorizontalSeparator(point.y);
		this.page.draw();
		return true;
	}

	this.separatorCreator.addVerticalSeparators(point.x);
	this.page.draw();
	return true;
};