﻿FC.Viewmodels.DocumentEditor.Binder = function (items, point, onend) {
	var maxHeight = 250;
	var totalHeight = $(document).height();

	this.items = items;
	this.binderStyle = "top: " + (point.y + maxHeight < totalHeight ? point.y : totalHeight - maxHeight) +
		"px; left: " + point.x + "px;";

	this.endCallback = onend;
};

FC.Viewmodels.DocumentEditor.Binder.prototype.showBase = function () {
	if (!this.items || this.items.length === 0) {
		if (this.endCallback) {
			this.endCallback();
		}

		return;
	}

	var markup = "<div class=\"binderContainer\"><div class=\"binder\" style=\"" + this.binderStyle + "\"></div></div>";
	$('#panel_1').append(markup);

	var binder = $(".binder");
	var self = this;
	var wasSeparator = false;
	for (var i = 0; i < this.items.length; i++) {
		var id = "binder_" + (i + 1);

		if (this.items[i].isSeparator) {
			binder.append("<div class=\"binder-item  binder-separator  binder-collapsed\" id=\"" + id + "\">" +
				"<span class=\"docdetails--triangle  bender-expander  docdetails--triangle-down\"></span>" +
				"<span class=\"bender-separator-text\">" + this.items[i].text + "</span></div>");

			$("#" + id).on("mousedown.binder", function (event) {
				var separator = $(event.currentTarget);

				if (separator.hasClass("binder-collapsed")) {
					$(".binder-item-hideable").show();
				} else {
					$(".binder-item-hideable").hide();
				}

				var expander = separator.find("span");
				expander.toggleClass("docdetails--triangle-up");
				expander.toggleClass("docdetails--triangle-down");
				separator.toggleClass("binder-collapsed");
			});

			wasSeparator = true;
		} else {
			binder.append("<div class=\"binder-item" + (wasSeparator ? " binder-item-hideable" : "") +
				(this.items[i].boldify ? " binder-item-bold" : "") +
				"\" id=\"" + id + "\">" + this.items[i].text + "</div>");

			var elem = $("#" + id);
			elem.on("mousedown.binder", this.items[i], function (event) { self.onSelect(event.data); });
			if (wasSeparator) {
				elem.hide();
			}
		}
	}

	binder.on("mousedown.binder", function (event) { event.stopPropagation(); });
	$(".binderContainer").on("mousedown.binder", function () { self.onEnd(self); });
	$(".binderContainer").on("mousemove.binder", function (event) {
		event.stopPropagation();
		return false;
	});
	$(".binderContainer").on("mouseleave.binder", function (event) { event.stopPropagation(); });
	$(".binderContainer").on("wheel.binder", function (event) { event.stopPropagation(); });
};

FC.Viewmodels.DocumentEditor.Binder.prototype.show = function () {
	this.showBase();
};

FC.Viewmodels.DocumentEditor.Binder.prototype.onEnd = function (binder) {
	$(".binderContainer").off("mousedown.binder");
	$(".binderContainer").off("mousemove.binder");
	$(".binderContainer").off("mouseleave.binder");
	$(".binderContainer").off("wheel.binder");
	$(".binderContainer").remove();

	if (binder.endCallback) {
		binder.endCallback();
	}
};

FC.Viewmodels.DocumentEditor.Binder.prototype.onSelect = function () {
	this.onEnd();
};