﻿FC.Viewmodels.DocumentEditor.ColumnBinder = function (tableRegion, column, event, page) {

	var point = { x: event.pageX, y: event.pageY };
	this.tableRegion = tableRegion;
	this.column = column;

	var cellRegions = tableRegion.regions();
	var possibleColumns = [];
	var i;

	var visiblePercent = 0.3;

	if (cellRegions) {
		for (i = 0; i < cellRegions.length; i++) {
			if (!cellRegions[i].field()) {
				continue;
			}

			var extRect = cellRegions[i].getExternalRect();
			if (extRect.x1 > column.rightPos() || extRect.x2 < column.leftPos()) {
				continue;
			}
			var width = extRect.x2 - extRect.x1;
			var visibleWidth;
			if (extRect.x2 >= column.rightPos()) {
				visibleWidth = column.rightPos() - extRect.x1;
			} else {
				visibleWidth = extRect.x2 - column.leftPos();
			}

			if (visibleWidth < width * visiblePercent) {
				continue;
			}

			possibleColumns.push(cellRegions[i].field().id());
		}
	}

	var columns = tableRegion.columns();
	var cells = tableRegion.model.dummyRow.Cells;
	var items = [];
	for (i = 0; i < cells.length; i++) {
		var columnBinded = false;
		for (var j = 0; j < columns.length; j++) {
			if (columns[j].id() === cells[i].Id) {
				columnBinded = true;
				break;
			}
		}

		if (!columnBinded) {
			items.push({
				text: cells[i].Caption ? cells[i].Caption : cells[i].Name,
				id: cells[i].Id, 
				boldify: possibleColumns.indexOf(cells[i].Id) > -1
			});
		}
	}

	items.sort(function (item1, item2) {
		if (item1.boldify) {
			if (item2.boldify) {
				return item1.text > item2.text ? 1 : -1;
			}

			return -1;
		}

		if (item2.boldify) {
			return 1;
		}

		return item1.text > item2.text ? 1 : -1;
	});

	FC.Viewmodels.DocumentEditor.Binder.call(this, items, point, function() {
		page.directDrawer.clear();
		page.draw();
	});
};

FC.Viewmodels.DocumentEditor.ColumnBinder.prototype = Object.create(FC.Viewmodels.DocumentEditor.Binder.prototype);

FC.Viewmodels.DocumentEditor.ColumnBinder.prototype.onSelect = function (item) {
	this.column.id(item.id);
	this.column.caption(item.text);
	this.tableRegion.recalculateCellsInColumn(this.column);
	this.onEnd(this);
};