﻿var FC = FC || {};
FC.Viewmodels = FC.Viewmodels || {};
FC.Viewmodels.DocumentEditor = FC.Viewmodels.DocumentEditor || {};

FC.Viewmodels.DocumentEditor.DocumentRegionsPanel = function (currentDocument, docInfo, selectedField, selectedParagraph, moveFormToField, documentDataContext, readonlyMode) {
	var self = this;


	self.currentDocument = currentDocument;

	self.pages = ko.observableArray([]);

	self.textSelectingMode = ko.observable(false);
	self.lastSelectedText = ko.observable("");

	self.regionModifying = ko.observable(false);	

	$(document).on("keydown", function (e) {
		if (e.which === 16) {
			self.regionModifying(true);
		}
	});

	$(document).on("keyup", function (e) {
		if (e.which === 16) {
			self.regionModifying(false);
		}
	});

	self.deselectAllRegions = function (onlyHovering, regionsToDeselect, pageId) {
		var pages = self.pages();
		if (!pages) {
			return;
		}

		for (var i = 0; i < pages.length; i++) {
			if (typeof (pageId) === "undefined" || pageId === pages[i].id()) {
				if (pages[i].deselectPageRegions(onlyHovering, regionsToDeselect)) {
					pages[i].draw();
				}
			}
		}
	};

	self.unhighlightRegions = function () {
		var pages = self.pages();
		if (!pages) {
			return;
		}

		for (var i = 0; i < pages.length; i++) {
			if (pages[i].unhighlightPageRegions()) {
				pages[i].draw();
			}
		}
	}

	self.currentDocument.subscribe(function (doc) {
		var oldPages = self.pages();
		if (oldPages) {
			for (var i = 0; i < oldPages.length; i++) {
				oldPages[i].dispose();
			}
		}


		if (!doc) {
			self.pages([]);
			return;
		}
		self.pages($.map(doc.pages(),
			function (page) {
				return new FC.Viewmodels.DocumentEditor.PageViewModel(page, doc, selectedField, selectedParagraph, moveFormToField, documentDataContext, self, readonlyMode);
			}));
	});

};