﻿FC.Viewmodels.DocumentEditor.GroupCellRegionViewModel = function (region, parentRegion, page, depth) {
	FC.Viewmodels.DocumentEditor.RegionViewModel.call(this, region, parentRegion, page, depth);

	var self = this;
	this.caption = ko.computed(function() {

			var field = self.field();
			if (field &&
				field.parent &&
				field.parent.parent) {
				return region.caption() + "[" + (field.parent.parent.rows().indexOf(field.parent) + 1) + "]";
			} else {
				return region.caption();
			}
		},
		this);

	this.page.subscriptions.push({
		key: this.target,
		value: this.caption
	});

	this.selected.subscribe(function(newValue) {

		var field = self.field();
		if (field &&
			field.parent &&
			field.parent.parent) {
			var table = field.parent.parent;
			var row = field.parent;
			var section = table.getCurrentSection();
			var sectionIsFlexible = section.isFlexible();

			var docEditor = window.batchLayout.batchLayoutViewModel.DocumentEditor();
			var rowIndex = table.rows().indexOf(row);
			if (newValue && sectionIsFlexible) {
				docEditor.extender.selectedTableRow(rowIndex);
				docEditor.extender.selectedTableRowPath(table.getNodeRef());
				docEditor.extender.selectedTableCanReanalyze(true);
			} else {
				if (docEditor.extender.selectedTableRow() === rowIndex || !sectionIsFlexible) {
					docEditor.extender.selectedTableRow(-1);
					docEditor.extender.selectedTableRowPath("");
				}
			}
		}
	});
	this.page.subscriptions.push({
		key: this.target,
		value: this.selected
	});
};

FC.Viewmodels.DocumentEditor.GroupCellRegionViewModel.prototype = Object.create(FC.Viewmodels.DocumentEditor.RegionViewModel.prototype);

FC.Viewmodels.DocumentEditor.GroupCellRegionViewModel.prototype.createZones = function () {
	if (!this.isVisible()) {
		return [];
	}

	var zones = this.createBasicZones();
	zones.push(new FC.Viewmodels.ActionZones.GroupCellBodyZone(this.rectangles, this, this.page, this.depth, this.parentRegion));
	return zones;
};

FC.Viewmodels.DocumentEditor.GroupCellRegionViewModel.prototype.onCellChange = function () {
	this.updateTextBase();
	this.model.status(1);
	this.field().needRecognize(true);
};