﻿FC.Viewmodels.DocumentEditor.TableGroupRegionViewModel = function (region, parentRegion, page, depth) {
	FC.Viewmodels.DocumentEditor.TableRegionViewModel.call(this, region, parentRegion, page, depth);

	this.cellsSizesRelateToParent = false;
};

FC.Viewmodels.DocumentEditor.TableGroupRegionViewModel.prototype = Object.create(FC.Viewmodels.DocumentEditor.TableRegionViewModel.prototype);

FC.Viewmodels.DocumentEditor.TableGroupRegionViewModel.prototype.createZones = function () {
	var zones = this.createCommonTableZones();

	if (this.isVisible()) {
		zones.push(new FC.Viewmodels.ActionZones.TableGroupZone(this.rectangles, this, this.page, this.depth));
	}

	return zones;
};

FC.Viewmodels.DocumentEditor.TableGroupRegionViewModel.prototype.getExternalRect = function () {
	return FC.Viewmodels.DocumentEditor.GroupRegionViewModel.getGroupExternalRect(this);
};

FC.Viewmodels.DocumentEditor.TableGroupRegionViewModel.prototype.createCellRegion = function (cellModel, row, column) {
	var rectangle = new FC.BusinessModels.DocumentEditor.Coordinates({
		X1: column.leftPos(),
		X2: column.rightPos(),
		Y1: row.topSeparator(),
		Y2: row.bottomSeparator()
	});

	var textRegions = FC.Viewmodels.ActionZones.RecognizedTextZone.getRegionsInsideRectangle(rectangle, this.page);

	if (!textRegions || textRegions.length === 0) {
		return;
	}

	var text = FC.Viewmodels.DocumentEditor.TextRegionViewModel.getTextFromRegions(textRegions);

	var coords = { X1: 1000000, X2: -1000000, Y1: 1000000, Y2: -1000000 };
	for (var i = 0; i < textRegions.length; i++) {
		if (textRegions[i].rectangles()[0].x1() < coords.X1) {
			coords.X1 = textRegions[i].rectangles()[0].x1();
		} 

		if (textRegions[i].rectangles()[0].y1() < coords.Y1) {
			coords.Y1 = textRegions[i].rectangles()[0].y1();
		}

		if (textRegions[i].rectangles()[0].x2() > coords.X2) {
			coords.X2 = textRegions[i].rectangles()[0].x2();
		}

		if (textRegions[i].rectangles()[0].y2() > coords.Y2) {
			coords.Y2 = textRegions[i].rectangles()[0].y2();
		}
	}

	this.page.createRegionForField({ Coordinates: [coords], Status: 2, PageId: this.page.id() }, this, cellModel, text);
};
