﻿FC.Viewmodels = FC.Viewmodels || {};
FC.Viewmodels.FormEditor = FC.Viewmodels.FormEditor || {};

FC.Viewmodels.FormEditor.DbLookupEditableEntityItem = function (initInfo) {
	this.columnName = initInfo.columnDescription.name;
	this.cannotBeEmpty = initInfo.columnDescription.canNotBeEmpty;
	this.columnCaption = initInfo.columnCaption;
	this.maxValuesNumber = initInfo.columnDescription.maxVariantCount;
	this.maxValuesMessage = FC.Environment.Localization.DbLookup.MaxValuesMessage.replace("{field}", this.columnCaption)
		.replace("{number}", this.maxValuesNumber);
	this.values = ko.observableArray($.map(initInfo.values,
		function (val) {
			return new FC.Viewmodels.FormEditor.DbLookupEditableEntityItemValue(val);
		}));

	this.order = initInfo.order;
	this.onResize = initInfo.onResize;
	if (!this.values() || this.values().length === 0) {
		this.values([new FC.Viewmodels.FormEditor.DbLookupEditableEntityItemValue('')]);
	}
	this.isPrimaryKey = initInfo.columnDescription.isPrimaryKey;
	this.isFilteringKey = initInfo.columnDescription.isFilteringKey;

	this.addValue = function (index) {
		if (this.values().length < this.maxValuesNumber) {
			this.values.splice(index + 1, 0, new FC.Viewmodels.FormEditor.DbLookupEditableEntityItemValue(''));
			if (this.onResize) {
				this.onResize();
			}
		}
	}

	this.removeValue = function (index) {
		this.values.splice(index, 1);
		if (this.onResize) {
			this.onResize();
		}
	}

	this.addAvailable = ko.computed(function () {
		return this.values().length < this.maxValuesNumber;
	}, this);

	this.removeAvailable = ko.computed(function () {
		return this.values().length > 1;
	}, this);


	this.focusedValue = ko.computed(function () {
		return this.values().filter(function (val) { return val.hasFocus(); })[0];
	}, this);
}
