﻿FC.Viewmodels = FC.Viewmodels || {};
FC.Viewmodels.FormEditor = FC.Viewmodels.FormEditor || {};

/**
 * 
 * @param {} datasetColumns Список колонок в DataSetе
 * @param {} editableEntity значения изменяемой записи
 * @param {} keyField 
 * @param {} fieldsCaption Caption полей
 * @param {} mode режим FC.Viewmodels.FormEditor.DbLookupViewmodelModes
 * @returns {} 
 */
FC.Viewmodels.FormEditor.DbLookupEditableEntity = function (datasetColumns, fieldsCaption, editableEntity, onResize, mode) {
	this.datasetColumns = datasetColumns;
	this.editableEntity = editableEntity;
	this.fieldsCaption = fieldsCaption;
	this.mode = mode;


	this.entityDescription = [];

	for (var i = 0; i < datasetColumns.length; i++) {
		var datasetColumn = datasetColumns[i];
		if (!fieldsCaption[datasetColumn.name]) {
			continue;
		}


		var values = [];
		if (editableEntity) {
			for (var j = 0; j < editableEntity.length; j++) {
				if (editableEntity[j].FieldName === datasetColumn.name &&
					editableEntity[j].FieldValue &&
					(!datasetColumn.isPrimaryKey || this.mode !== FC.Viewmodels.FormEditor.DbLookupViewmodelModes.ADD)) {
					values.push(editableEntity[j].FieldValue);
				}
			}
		}

		this.entityDescription.push(new FC.Viewmodels.FormEditor.DbLookupEditableEntityItem({
			columnDescription: datasetColumn,
			columnCaption: fieldsCaption[datasetColumn.name].caption,
			values: values,
			onResize: onResize,
			order: fieldsCaption[datasetColumn.name].order
		}));

	}

	this.entityDescription = this.entityDescription.sort(function (left,
		right) {
		if (left.order < right.order) return -1;
		if (left.order > right.order) return 1;
		return 0;
	});

	this.valueWithFocus = ko.computed(function () {

		for (var i = 0; i < this.entityDescription.length; i++) {
			if (this.entityDescription[i].focusedValue()) {
				return this.entityDescription[i].focusedValue();
			}
		}
		return null;
	}, this);

	this.cannotBeSaved = ko.computed(function () {
		return this.entityDescription
			.filter(function(entity) {
				if (!entity.cannotBeEmpty ||
					(entity.isPrimaryKey && mode === FC.Viewmodels.FormEditor.DbLookupViewmodelModes.ADD)) {
					return false;
				}
				return entity.values()
					.filter(function(val) {
						return !!val.value();
					}).length === 0;
			}).length > 0;
	}, this);
}
