﻿FC.Viewmodels = FC.Viewmodels || {};
FC.Viewmodels.FormEditor = FC.Viewmodels.FormEditor || {};


FC.Viewmodels.FormEditor.DbLookupVariant = function(elements, fieldsCaptions) {

	function boldifyValue(currentField) {
		var value = currentField.FieldValue;
		if (currentField.BoldMask && (currentField.BoldMask.length !== 0)) {
			var lastPos = -1;
			var charPos;
			for (charPos = currentField.BoldMask.length - 1; charPos >= 0; charPos--) {
				if (currentField.BoldMask[charPos] === '0') {
					if (lastPos >= 0) {
						value = value.slice(0, lastPos + 1) + '</b>' + value.slice(lastPos + 1);
						value = value.slice(0, charPos + 1) + '<b>' + value.slice(charPos + 1);
						lastPos = -1;
					}
				} else if (currentField.BoldMask[charPos] === '1') {
					if (lastPos < 0)
						lastPos = charPos;
				}
			}
			if (lastPos > 0) {
				value = value.slice(0, lastPos + 1) + '</b>' + value.slice(lastPos + 1);
				value = '<b>' + value.slice(charPos + 1);
			}
		}

		return value;
	}


	this.allFields = {};
	for (var i = 0; i < elements.length; i++) {
		this.allFields[elements[i].FieldName] = elements[i].FieldValue;
	}


	this.elements = elements
		.filter(function (val) { return fieldsCaptions[val.FieldName]; })
		.sort(function (left, right) {
			var leftDescr = fieldsCaptions[left.FieldName];
			var rightDescr = fieldsCaptions[right.FieldName];
			if (leftDescr.order < rightDescr.order) return -1;
			if (leftDescr.order > rightDescr.order) return 1;
			return 0;
		}).map(
		function(resItem) {
			return {
				name: resItem.FieldName,
				caption: fieldsCaptions[resItem.FieldName].caption || resItem.FieldName,
				value: resItem.FieldValue,
				boldedValue: boldifyValue(resItem),
				hasBold: (resItem.BoldMask && resItem.BoldMask.length > 0 && resItem.BoldMask.indexOf('1') >= 0)
			};
		});


	this.elementsDictionary = {};
	for (var i = 0; i < this.elements.length; i++) {
		this.elementsDictionary[this.elements[i].name] = this.elements[i].value;
	}


	this.boldedElements = this.elements.slice(1).filter(function(val) { return val.hasBold; });


	this.head = this.elements[0].boldedValue;
}