﻿FC.Viewmodels.DocumentEditor = FC.Viewmodels.DocumentEditor || {};
FC.Viewmodels.DocumentEditor.BooleanFieldAdapter = function (field, parent, selectedField, selectedParagraph, changeSubscribers) {
	var self = this;
	
	$.extend(self, new FC.Viewmodels.DocumentEditor.FieldAdapter(field, parent, selectedField, selectedParagraph, changeSubscribers));


	self.value = self.model.value;


	var baseVerify = self.rewritableFunctions.verify;
	self.rewritableFunctions.verify = function (goToNext) {
		if (goToNext == undefined)
			goToNext = true;
		baseVerify(null, goToNext);
	};

	self.rewritableFunctions.selectField = function (isSelected) {
		if (isSelected) {
			$("#" + self.DomId).prev().focus();
		} else {
			$("#" + self.DomId).prev().blur();
		}
	};

	var baseFormFieldValueCss = self.FormFieldValueCss;
	/* Стиль для формы данных - отражает состояния поля */
	self.FormFieldValueCss = ko.pureComputed(function () {
		var css = baseFormFieldValueCss();
		css["field_checkbox"] = true;
		return css;
	});



	self.ElementBottomLine = ko.observable(0);

	self.updateElementBottomLine = function() {
		self.ElementBottomLine($("#" + self.DomId).parent().outerHeight());
	};

	self.disposables.push(ko.computed(function () {
		var selected = self.showBalloon();
		self.updateElementBottomLine();
	}));


	self.ValueChanged = function (data, event) {
		if (self.readOnly()) {
			event.preventDefault();
		} else {
			self.notifyValueChanged(self.value());
			FC.Viewmodels.EventStack.addEvent();

			self.rewritableFunctions.verify(false);
			self.model.manipulators.dbCheckRulesManipulator.tryRecount([self.model], []);
		}

		if (self.model.needRecognize()) {
			self.model.needRecognize(false);
		}

		return true;
	};

	self.valueHash = ko.computed(function () {
		return self.value() + '';
	});
	self.disposables.push(self.valueHash);

}