﻿FC.Viewmodels.DocumentEditor = FC.Viewmodels.DocumentEditor || {};

FC.Viewmodels.DocumentEditor.FieldWithChildren = function (self, field, mapped, selectedField, selectedParagraph, offsetInfo, changeSubscribers) {

	self.children = ko.observableArray([]);

	ko.computed(function () {
		var t0 = performance.now();
		var fieldObj = field;
		if (jQuery.isFunction(field)) {
			fieldObj = field();
		}
		if (!fieldObj) {
			self.children([]);
			return;
		}
		var childElements = [];
		if (mapped) {
			$.each(fieldObj.fields(),
				function (ind, subField) {
					if (!subField.isVisible()) {
						return;
					}

					var child = self.children()[subField.id()];
					if (child && child.model == subField) {
						childElements[subField.id()] = child;
					} else {
						childElements[subField.id()] = FC.Viewmodels.FormEditor.FieldViewmodelAlgo.generateField(subField, self, selectedField, selectedParagraph, offsetInfo, changeSubscribers);
					}
				});
			
			for (var lastNotNull = childElements.length - 1; lastNotNull >= 0; lastNotNull--) {

				if (childElements[lastNotNull]) break;
			}
			if (lastNotNull !== (childElements.length - 1)) {
				childElements.splice(lastNotNull + 1, childElements.length - lastNotNull);
			}
		} else {
			$.each(fieldObj.fields(), function (ind, subField) {
				for (var i = 0; i < self.children().length; i++) {
					var child = self.children()[i];
					if (child.model === subField) {
						childElements.push(child);
						return;
					}
				}
				childElements.push(FC.Viewmodels.FormEditor.FieldViewmodelAlgo.generateField(subField, self, selectedField, selectedParagraph, offsetInfo, changeSubscribers));
			});
		}

		if (childElements.length !== self.children().length) {
			self.children(childElements);
		}
		for (var i = 0; i < childElements.length; i++) {
			if (childElements[i] != self.children()[i]) {
				self.children(childElements);
				break;
			}
		}

		FC.Utils.EventLogger.Default.addMessage('FieldsPanel', "FieldWithChildren updating - " + (performance.now() - t0) + " ms");
	});
}