﻿FC.Viewmodels.DocumentEditor.FieldWithColumns = function (self, childrenModels, grandChildrenGetter, offsetInfo) {
	self.columnsOrder = ko.observableArray();
	self.hideableColumns = ko.observableArray([]);
	self.allColumns = ko.computed(function () {
		var rows = childrenModels();
		if (!rows || rows.length === 0) return [];
		var res = $.map(grandChildrenGetter(rows[0]),
			function (cell) {
				if (cell && cell.isVisible())
					return { id: cell.id(), name: cell.caption() };
			});
		if (self.columnsOrder().length > 0) {
			var sortedRes = $.map(self.columnsOrder(),
				function (id) {
					for (var i = 0; i < res.length; i++) {
						var resElem = res[i];
						if (resElem.id === id) {
							return resElem;
						}
					}
				}).filter(function (val) { return val; });
			res = sortedRes;
		}

		return res;
	});

	self.emptyColumns = ko.computed(function () {
		var rows = childrenModels();
		if (!rows || rows.length === 0) return [];
		var ids = [];
		$.each(grandChildrenGetter(rows[0]),
			function (ind, cell) {
				if (cell instanceof FC.BusinessModels.DocumentEditor.TextField && (!cell.value() || cell.value().length === 0)) {
					ids.push(cell.id());
				}
			});

		for (var i = 1; ids.length > 0 && i < rows.length; i++) {
			var cells = grandChildrenGetter(rows[i]);
			for (var j = 0; j < cells.length; j++) {
				if (!(cells[j] instanceof FC.BusinessModels.DocumentEditor.TextField) ||
					(cells[j].value() && cells[j].value().length > 0)) {
					var idIndex = ids.indexOf(cells[j].id());
					if (idIndex >= 0) {
						ids.splice(idIndex, 1);
					}
				}
			}
		}

		return ids;
	});

	self.hideableEmptyColumns = ko.computed(function () {
		var emptyColumns = self.emptyColumns();
		if (!emptyColumns || emptyColumns.length == 0) {
			return [];
		}
		var res = [];
		$.each(self.hideableColumns(),
			function (ind, hideableColumn) {
				if (emptyColumns.indexOf(hideableColumn) >= 0) {
					res.push(hideableColumn);
				}
			});
		return res;
	});

	self.columnSelector = new FC.Viewmodels.DocumentEditor.ColumnSelector(self.allColumns, self.hideableColumns, offsetInfo);
};