﻿FC.Viewmodels.DocumentEditor = FC.Viewmodels.DocumentEditor || {};
/**
* Инструмент для работы со стеком Undo/Redo-операций текстового поля
*/
FC.Viewmodels.DocumentEditor.TextFieldUndoEngine = function () {
	var self = this;

	// стек состояний текстового поля
	var stack = [];

	// индекс текущего состояния в стеке
	var index = -1;	

	// возвращает предыдущее состояние текстового поля
	// или null, если дошли до начала стека
	self.undo = function () {
		if (index === -1 || index === 0) {
			return null;
		}

		index = index - 1;
		return stack[index];
	}

	// возвращает следующее состояние текстового поля
	self.redo = function () {
		
		if (index === (stack.length - 1)) {
			return null;
		}

		index = index + 1;		
		return stack[index];
	}

	// добавление нового состояния в стек
	self.add = function (item) {

		if (!item) {
			return;
		}		

		if (index !== (stack.length - 1)) {
			stack.splice(index + 1, stack.length - index - 1);
		}

		stack.push(item);
		index = index + 1;
	}
};