﻿FC.Viewmodels.FormEditor.FormHorizontalScroll = function (containerElement, scrollableElement) {
	var windowResized = ko.observable(true);

	var horizontalContainerSize = ko.computed(function () {
		var container = containerElement();
		var scrollable = scrollableElement();
		var wResized = windowResized();
		if (!container || !scrollable) {
			return 0;
		}

		return $(container).outerWidth();
	});

	var horizontalScrollableSize = ko.computed(function () {
		var container = containerElement();
		var scrollable = scrollableElement();
		var wResized = windowResized();
		if (!container || !scrollable ) {
			return 0;
		}

		return $(scrollable).outerWidth();
	});

	var offsetX = ko.observable(0);
	var onScrollMove = function () {
		var container = containerElement();
		container.scrollLeft = offsetX();
		containerElement.valueHasMutated();
	};

	FC.ScrollBarNew.call(this,
		FC.ScrollBarNew.Orientation.Horizontal,
		horizontalContainerSize,
		offsetX,
		horizontalContainerSize,
		horizontalScrollableSize,
		null,
		onScrollMove);

	this.windowResized = windowResized;
};

FC.Viewmodels.FormEditor.FormHorizontalScroll.prototype = Object.create(FC.ScrollBarNew.prototype);
