﻿/**
 * Точка, изменения которой ограничены min и max значениями
 * @param {} x значение по x 
 * @param {} y значение по y
 * @param {} xMin минимальное значение по x
 * @param {} xMax максимальное значение по x
 * @param {} yMin  минимальное значение по y
 * @param {} yMax  максимальное значение по y
 * @param {} related значения, которые изменяются при изменении этой точки
 * @param {} pointType тип точки - на правой части фигуры 0, на левой части фигуры 1
 * @returns {} 
 */
FC.Viewmodels.ImageEditor.LimitedPoint = function (x, y, xMin, xMax, yMin, yMax, related, pointType) {
	this.x = x;
	this.y = y;

	this.xMin = xMin;
	this.xMax = xMax;
	this.yMin = yMin;
	this.yMax = yMax;

	this.related = related;

	this.pointType = pointType;
};