﻿/**
 * Вьюмодель для очереди
 */
FC.Viewmodels.QueueAdapter = function queueAdapter(queue) {
	var self = this;

	$.extend(self, new FC.BusinessModels.QueueProperties(queue));	

	self.MaxPriorityIconUrl = ko.observable('');

	self.MaxPriorityIconVisible = ko.observable(false);

	var maxPriority = self.MaxPriority();
	if (Math.abs(maxPriority) === 2 || Math.abs(maxPriority) === 1) {
		self.MaxPriorityIconVisible(true);
	}
};

FC.Viewmodels.QueueAdapter.GetPriorityIcon = function (priority) {
	switch (priority) {
		case 2: return FC.Environment.AppPathNoTennant + "Content/Images/PriorityHighest.png";
		case 1: return FC.Environment.AppPathNoTennant + "Content/Images/PriorityHigh.png";
		case -1: return FC.Environment.AppPathNoTennant + "Content/Images/PriorityLow.png";
		case -2: return FC.Environment.AppPathNoTennant + "Content/Images/PriorityLowest.png";
	};

	return '';
};

FC.Viewmodels.QueueAdapter.QueuesEquals = function(queuesA, queuesB) {
	if (!queuesA && !queuesB) {
		return true;
	}

	if (!queuesA || !queuesB) {
		return false;
	}

	if (queuesA.length !== queuesB.length) {
		return false;
	}

	for (var i = 0; i < queuesA.length; i++) {
		if (queuesA[i].QueueName() !== queuesB[i].QueueName() ||
			queuesA[i].QueueImageUrl() !== queuesB[i].QueueImageUrl() ||
			queuesA[i].QueueImageVisible() !== queuesB[i].QueueImageVisible() ||
			queuesA[i].StageTypeString() !== queuesB[i].StageTypeString() ||
			queuesA[i].StageIdsString() !== queuesB[i].StageIdsString() ||
			queuesA[i].QueueHasTasks() !== queuesB[i].QueueHasTasks() ||
			queuesA[i].MaxPriority() !== queuesB[i].MaxPriority() ||
			queuesA[i].PersonalTaskCount() !== queuesB[i].PersonalTaskCount() ||
			queuesA[i].FormedTaskCount() !== queuesB[i].FormedTaskCount()) {

			return false;
		}
	}

	return true;
};
