﻿FC.Viewmodels.Validation = FC.Viewmodels.Validation || {};
FC.Viewmodels.Validation.testNumberValidator = function () {
	var self = this;

	var defaultServerValidator = {
		IsInteger: false,
		DecimalSeparators: ['.', ',', '-', '='],
		CanBeEmpty: false,
		TreatErrorsAsWarnings: false,
		GroupSeparators: ['.', ',', '\''],
		CheckInterval: true,
		MinValue: 0,
		MaxValue: 10000000,
		CanHaveMinusOnRight: true,
		CanHaveParentheses: true,
		FractionalPartMaxLength: 2,
		FractionalPartObligatory: true,
		ValidatorType: 'NumberValidator'
	};

	self.CreateValidator = function (serverValidator) {
		return new FC.Viewmodels.Validation.NumberValidator(serverValidator);
	};

	self.TestValidator = function (validator, text, supposedResult) {
		var result = validator.Validate(text);

		if (result !== supposedResult) {
			console.warn('Failed! Value: ' + text + '/ Result:' + result);
		} else {
			console.log('Value: ' + text + ' passed test');
		}
	};

	var validator = self.CreateValidator(defaultServerValidator);
	self.TestValidator(validator, '12.3', true);
	self.TestValidator(validator, '1234552.3', true);
	self.TestValidator(validator, '1,234,552.3', true);
	self.TestValidator(validator, '(1,234,552.3)', true);
	self.TestValidator(validator, '((1,234,552.3)', false);
	self.TestValidator(validator, '(-1,234,552.3)', true);
	self.TestValidator(validator, '(1,234,552.3-)', true);
	self.TestValidator(validator, '(-1,234,552.3-)', false);
	self.TestValidator(validator, '(1,234,55-2.3)', false);
	self.TestValidator(validator, '1,234,552.31234', false);
	self.TestValidator(validator, '11,2,.34,552.3', false);
};