﻿FC.Viewmodels.SelectionStack = function selectionStack() {
	var self = this;

	self.lastId = 0;

	self.getId = function () { return ++self.lastId; };

	self.selectedElements = [];

	self.deselectExcept = function (id, deselectFunc) {
		self.deselectExceptCondition(
			function (element) {
				return element._id === id;
			},
			deselectFunc);
	};

	self.deselectExceptCondition = function (condition, deselectFunc) {
		var i = 0;
		while (i < self.selectedElements.length) {
			if (condition(self.selectedElements[i])) {
				i++;
			} else {
				if (deselectFunc) {
					deselectFunc(self.selectedElements[i]);
				}

				self.selectedElements.splice(i, 1);
			}
		}
	};

	self.removeIfExist = function (id) {
		for (var i = 0; i < self.selectedElements.length; i++) {
			if (self.selectedElements[i]._id === id) {
				self.selectedElements.splice(i, 1);
				return;
			}
		}
	};

	self.removeAll = function () {
		self.selectedElements = [];
	};

	self.addToSelected = function (region) {
		self.selectedElements.push(region);
	};
};